<?php
//----------------------------------------------------------------------------//
    $rpm_qa_wget = rpm_qa_wget ( ) ;
//----------------------------------------------------------------------------//
    $Themes = Get_Files ( $Constants['Paths']['cPanel']['Themes'] ) ;
    natcasesort ( $Themes ) ;
//----------------------------------------------------------------------------//
    $Users = Get_Files ( $Constants['Paths']['cPanel']['Users'] ) ;
    natcasesort ( $Users ) ;
//----------------------------------------------------------------------------//
    if ( $Secondary_Action == 'Pre' )
    {
//----------------------------------------------------------------------------//
        if ( 'Off' == Get_License_Status ( ) )
        {
//----------------------------------------------------------------------------//
?>
    <div class="Block">
        <h1 class="Failure"><?php echo Get_Message ( 'This server is not properly licensed.' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Your main server IP as currently seen by our servers is %s.%sIf you have submitted a different IP for licensing, please contact your NOC if this is a NOC license or email %s with order number, currently licensed IP and new IP (%s) if this is a self-purchased license.%sIf this is a self-purchased license, it may also have expired. In this case, please follow the payment link in the renewal notification which you have received by email in order to renew your license.%sIf you ran a demo version of Fantastico, you now need to %spurchase a full license.%s' , Array ( '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<a href="mailto:sales@netenberg.com">sales@netenberg.com</a>' , '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<br/>' , '<a href="http://netenberg.com/shop/" target="_blank">' , '</a>' ) ) ; ?>
        </p>
    </div>
<?php
//----------------------------------------------------------------------------//
        }
        else if ( 'Unknown' == Get_License_Status ( ) )
        {
//----------------------------------------------------------------------------//
?>
    <div class="Block">
        <h1 class="Failure"><?php echo Get_Message ( 'Unable to determine license status' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Fantastico De Luxe WHM Admin was unable to determine the license status. It is most likely that your firewall is blocking it. Please see this %spost%s.' , Array ( '<a href="http://www.netenberg.com/forum/index.php?topic=3093.0" target="_blank">' , '</a>' ) ) ; ?>
        </p>
    </div>
<?php
//----------------------------------------------------------------------------//
        }
        else if ( FALSE == empty ( $rpm_qa_wget ) )
        {
?>
    <div class="Block">
        <h1 class="Failure"><?php echo Get_Message ( 'Fatal Error' ) ?></h1>
        <p class="Failure">
            <?php echo Get_Message ( 'You have a buggy version of wget (%s). %sBefore proceeding with installation/upgrade,%s please see the following page for instructions on how to fix: %s' , Array ( $rpm_qa_wget , '<strong>' , '</strong>' , '<a href="http://www.netenberg.com/forum/index.php?topic=5430.0" title="" target="_blank" class="Failure">http://www.netenberg.com/forum/index.php?topic=5430.0</a>' ) ) ; ?>
        </p>
    </div>
<?php
        }
        else
        {
//----------------------------------------------------------------------------//
?>

<div class="Block">
    <h1 class="Failure"><?php echo Get_Message ( 'This installer will REMOVE any older installation of Fantastico De Luxe found on this server' ) ; ?></h1>
</div>

<form action="<?php echo $Constants['URLs']['WHM']['Fantastico_De_Luxe'] ; ?>fantastico.php" onsubmit="return Validate ( this ) ;">

<div class="Block">
    <p>
        <span class="Success"><strong><?php echo Get_Message ( 'Select version' ) ; ?></strong></span>
        <br/>
        <?php echo Get_Message ( 'Select which Fantastico De Luxe version you want to install. "Latest" offers you the latest features. "Stable" may have less features but it is proven to have less bugs.' ) ; ?>
    </p>

    <p>
        <select id="Update_To" name="Update_To">
            <option value="Stable"><?php echo Get_Message ( 'Stable' ) ; ?> Fantastico <?php echo $Version_Numbers['Stable'] ; ?></option>
            <option value="Latest"><?php echo Get_Message ( 'Latest' ) ; ?> Fantastico <?php echo $Version_Numbers['Latest'] ; ?></option>
        </select>
    </p>
</div>
<div class="Block">

    <p>

        <span class="Success"><strong><?php echo Get_Message ( 'Select the cPanel themes that shall have a symlink to Fantastico (only themes checked here will have access to Fantastico if permitted by the WHM Features Manager).' ) ; ?></strong></span>
        <br/>
        <span class="Failure"><?php echo Get_Message ( 'Unchecked themes are known to not link to Fantastico even if a symlink exists, so you will not see a Fantastico link unless you modify them. Checked themes will not necessarily auto-link to Fantastico, they just are not in our negative list.' ) ; ?></span>
    </p>

    <p>

<?php
//----------------------------------------------------------------------------//
            $Temporary = Array ( ) ;
            foreach ( $Themes as $Theme )
            {
                if ( is_dir ( $Constants['Paths']['cPanel']['Themes'] . $Theme ) && !is_link ( $Constants['Paths']['cPanel']['Themes'] . $Theme ) && !ereg ( '^rv' , $Theme ) )
                {
                    $Checked = ' checked="checked"' ;
                    if ( $Theme == 'default' || $Theme == 'iconic' || $Theme == 'Xskin' || $Theme == 'xmail' || $Theme == 'vertex' || $Theme == 'mailonly' )
                    {
                        $Checked = '' ;
                    }
                    $Temporary[] = '<input id="Selected_Themes[]" name="Selected_Themes[]" type="checkbox" value="' . $Theme . '"' . $Checked . '/> ' . $Theme ;
                }
            }
            echo implode ( '<br/>' , $Temporary ) ;
//----------------------------------------------------------------------------//
?>

    </p>
</div>
<div class="Block">

    <p>
        <span class="Success"><strong><?php echo Get_Message ( 'Initially activate all scripts' ) ; ?></strong></span>
        <br/>
        <span class="Failure"><?php echo Get_Message ( 'Only active scripts can be accessed and installed by end users. You may activate/deactivate later using the Fantastico Admin Panel.' ) ; ?></span>
    </P>

    <p>
        <input name="Automatically_Activate_Scripts" type="checkbox" value="Yes" checked="checked"/><?php echo Get_Message ( ' Mark all scripts as "active"' ) ; ?>
    </p>
</div>
<div class="Block">

    <p>
        <span class="Success"><strong><?php echo Get_Message ( 'Enter full path and filename to the "wget" binaries' ) ; ?></strong></span>
        <br/>
        <?php echo Get_Message ( 'Fantastico needs fully working "wget" binaries with permissions set to at least 700 in order to work. For security reasons, you may have renamed the "wget" binaries. If so, enter here the full path and filename to the renamed "wget" binaries. LEAVE AS IS IF YOU DON&#39;T KNOW WHAT IT IS.' ) ; ?>
    </p>

    <p>
        <input type="text" name="wget" value="<?php echo $Private_Settings['Binaries']['wget'] ; ?>"/>
    </p>
</div>
<div class="Block">
    <p>
        <span class="Success"><strong><?php echo Get_Message ( 'wget time-out (in seconds)' ) ; ?></strong></span>
        <br/>
        <?php echo Get_Message ( 'If you are having problems connecting to our servers, set it to a value above 30.' ) ; ?>
    </p>
    <p>
        <input type="text" name="wget_Time_Out" value="<?php echo $Private_Settings['wget']['Time_Out'] ; ?>"/>
    </p>
</div>

    <div class="Block">

        <h1><?php echo Get_Message ( 'Location of the netenberg data directory' ) ; ?></h1>

        <p>
            <select name="Netenberg">
<?php
    $Directories = Get_Partitions_List ( ) ;
    foreach ( $Directories As $Key => $Value )
    {
        $Selected = '' ;
        if ( $Value['Value'] == str_replace ( '/' , '' , $Public_Settings['Paths']['Netenberg'] ) )
        {
            $Selected = ' selected="selected"' ;
        }
?>
                <option value="/<?php echo $Value['Value'] ; ?>/"<?php echo $Selected ; ?>><?php echo $Value['Caption'] ; ?></option>
<?php
    }
?>
            </select>
        </p>

    </div>

<?php

    /*

    <div class="Block">
        <p>
            <span class="Success"><strong><?php echo Get_Message ( 'Auto-Update Fantastico De Luxe once daily' ) ; ?></strong></span>
        </p>

        <p>
            <select name="Cron">
                <option value="Yes"><?php echo Get_Message ( 'Yes' ) ; ?></option>
                <option value="No"><?php echo Get_Message ( 'No' ) ; ?></option>
            </select>
        </p>
    </div>

    */

?>

    <div class="Block">
        <p>
            <span class="Success"><strong><?php echo Get_Message ( 'Cron notifications' ) ; ?></strong></span>
            <br/>
            <?php echo Get_Message ( 'Enter an email address to receive cron notifications (optional).' ) ; ?>
        </p>
        <p>
            <input type="text" name="Cron_E_Mail_Address" value="<?php echo $Private_Settings['Cron']['E_Mail_Address'] ; ?>" size="25" maxlength="255"/>
        </p>
    </div>

<div class="Block">

    <h1 class="Failure"><?php echo Get_Message ( 'After clicking on "Install", you will have to wait from 30 seconds to 5 minutes depending on your server&#39;s  internet connection speed.' ) ; ?></h1>

    <p class="Center">
        <input name="Submit" type="submit" value="<?php echo Get_Message ( 'Install' ) ; ?>"/>
    </p>

    <input name="Primary_Action"   type="hidden" value="Install"/>
    <input name="Secondary_Action" type="hidden" value="Post"/>

</div>

</form>

<?php
//----------------------------------------------------------------------------//
        }
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
    if ( $Secondary_Action == 'Post' )
    {
//----------------------------------------------------------------------------//
        if ( !file_exists ( $wget ) )
        {
//----------------------------------------------------------------------------//
?>

<div class="Block">
    <h1 class="Failure"><?php echo Get_Message ( 'Fatal Error' ) ; ?></h1>

    <p class="Failure">
        <?php echo Get_Message ( 'The wget binaries %s can not be found. Please make sure you are submitting the full path including filename.' , Array ( '<strong>' . $wget . '</strong>' ) ) ; ?>
    </p>

    <p>
        <?php echo Get_Message ( 'Please go back and retry.' ) ?>
    </p>
</div>
<?php
//----------------------------------------------------------------------------//
        }
        else if ( !is_executable ( $wget ) )
        {
//----------------------------------------------------------------------------//
?>

<div class="Block">
    <h1 class="Failure"><?php echo Get_Message ( 'Fatal Error' ) ?></h1>

    <p class="Failure">
        <?php echo Get_Message ( 'No permissions to run %s. You have to set permissions to at least 700:' , Array ( '<strong>' . $wget . '</strong>' ) ) ; ?>
        <br/>
        chmod 700 <?php echo  $wget ?>
    </p>

    <p>
        <?php echo Get_Message ( 'Please go back and retry.' ) ; ?>
    </p>
</div>

<?php
//----------------------------------------------------------------------------//
        }
        else if ( FALSE == empty ( $rpm_qa_wget ) )
        {
?>
    <div class="Block">
        <h1 class="Failure"><?php echo Get_Message ( 'Fatal Error' ) ?></h1>
        <p class="Failure">
            <?php echo Get_Message ( 'You have a buggy version of wget (%s). %sBefore proceeding with installation/upgrade,%s please see the following page for instructions on how to fix: %s' , Array ( $rpm_qa_wget , '<strong>' , '</strong>' , '<a href="http://www.netenberg.com/forum/index.php?topic=5430.0" title="" target="_blank" class="Failure">http://www.netenberg.com/forum/index.php?topic=5430.0</a>' ) ) ; ?>
        </p>
    </div>
<?php
        }
        else
        {
//----------------------------------------------------------------------------//
            $Public_Settings['Fantastico_De_Luxe']['Update_To'] = $Update_To ;
//----------------------------------------------------------------------------//
            $Error = Array ( ) ;
//----------------------------------------------------------------------------//
            $Error['Themes']                 = FALSE ;
            if ( !empty ( $Selected_Themes ) )
            {
            }
            else
            {
                $Error['Themes'] = TRUE ;
            }
//----------------------------------------------------------------------------//
            if ( TRUE == $Error['Themes'] )
            {
?>
    <div class="Block">

        <h1><?php echo Get_Message ( 'Please select at least one cPanel theme to have a symlink to Fantastico' ) ; ?></h1>

        <p>
            <?php echo Get_Message ( 'Please go back and retry.' ) ; ?>
        </p>

    </div>

<?php
//----------------------------------------------------------------------------//
            }
            else
            {
//----------------------------------------------------------------------------//
                $Private_Settings['Binaries' ]['wget'          ] = $wget                ;
                $Private_Settings['Cron'     ]['E_Mail_Address'] = $Cron_E_Mail_Address ;
                $Private_Settings['Debug'    ]['Status'        ] = 'Off'                ;
                $Private_Settings['Language' ]                   = 'English'            ;
                $Private_Settings['wget'     ]['Time_Out'      ] = $wget_Time_Out       ;
//----------------------------------------------------------------------------//
                $Public_Settings['Binaries'          ]['NetPBM'            ]                       = '/usr/bin/'                              ;
                $Public_Settings['Administrator'     ]['E_Mail_Address'    ]                       = ''                                       ;
                $Public_Settings['Language'          ]                                             = 'English'                                ;
                $Public_Settings['Licensing_Server'  ]                                             = Get_Random_Licensing_Server ( )          ;
                $Public_Settings['phpsuexec'         ]['Status'            ]                       = 'Off'                                    ;
                $Public_Settings['Fantastico_De_Luxe']['Status'            ]                       = 'On'                                     ;
                $Public_Settings['Fantastico_De_Luxe']['Update_To'         ]                       = $Update_To                               ;
                $Public_Settings['Paths'             ]['cPanel'            ]['Fantastico_De_Luxe'] = '/usr/local/cpanel/3rdparty/fantastico/' ;
//----------------------------------------------------------------------------//
                $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/'            ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
                $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/'  ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
                $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/features_sets/'       ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
                $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/private_settings.php' ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
                $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/public_settings.php'  ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
//----------------------------------------------------------------------------//
                $Command = 'rm -rf ' . $Netenberg . 'netenberg/archives/'            ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
                $Command = 'rm -rf ' . $Netenberg . 'netenberg/fantastico_de_luxe/'  ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
                $Command = 'rm -rf ' . $Netenberg . 'netenberg/features_sets/'       ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
                $Command = 'rm -rf ' . $Netenberg . 'netenberg/private_settings.php' ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
                $Command = 'rm -rf ' . $Netenberg . 'netenberg/public_settings.php'  ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
//----------------------------------------------------------------------------//
                $Public_Settings['Paths']['Netenberg'] = $Netenberg ;
//----------------------------------------------------------------------------//
                $Temporary = Check_And_Repair_Folders_And_Files ( ) ;
//----------------------------------------------------------------------------//
                $Command   = 'rm -rf ' . $Public_Settings['Paths']['cPanel']['Fantastico_De_Luxe'] ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
                $Command   = 'rm -rf ' . $Constants['Paths']['cPanel']['Themes'] . '*/fantastico' ;
                $Temporary = Get_Output ( $Command , 'Off' ) ;
//----------------------------------------------------------------------------//
                $Command   = 'mkdir ' . $Public_Settings['Paths']['cPanel']['Fantastico_De_Luxe'] ;
                $Temporary = Get_Output ( $Command , 'On' ) ;
                $Temporary = chmod ( $Public_Settings['Paths']['cPanel']['Fantastico_De_Luxe'] , 0755 ) ;
//----------------------------------------------------------------------------//
?>

<div class="Block">
    <h1 class="Yes_Padding"><?php echo Get_Message ( 'Fetching files' ) ; ?></h1>

<?php
//----------------------------------------------------------------------------//
                $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' . Get_tgz_Prefix ( ) . 'fantasticodlwhm.tgz' ;
                $Output  = Get_Output ( $Command , 'On' ) ;
//----------------------------------------------------------------------------//
                $wget = wget ( Get_tgz_Prefix ( ) . 'fantasticodlwhm.tgz' , $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' , 'Yes' ) ;
                if ( eregi ( $Constants['wget']['Saved'] , $wget['Output'] ) OR eregi ( $Constants['wget']['No_Newer'] , $wget['Output'] ) )
                {
                    $Temporary = Decompress ( $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' . Get_tgz_Prefix ( ) . 'fantasticodlwhm.tgz' , $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' ) ;
                    $Directory = $Public_Settings['Paths']['cPanel']['Fantastico_De_Luxe'] ;
                    $Command = 'cp ' . $Constants['cp']['Options'] . ' ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/fantastico/* ' . $Public_Settings['Paths']['cPanel']['Fantastico_De_Luxe'] ;
                    $Output = Get_Output ( $Command , 'On' ) ;
                    if ( !is_dir ( $Constants['Paths']['WHM']['Fantastico_De_Luxe'] ) )
                    {
                        $Temporary = mkdir ( $Constants['Paths']['WHM']['Fantastico_De_Luxe'] , 0755 ) ;
                    }
                    if ( is_dir ( $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/installer/' ) )
                    {
                        $Command = 'cp ' . $Constants['cp']['Options'] . ' ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/installer/* ' . $Constants['Paths']['WHM']['Fantastico_De_Luxe'] ;
                        $Output = Get_Output ( $Command , 'On' ) ;
                    }
                    if ( is_file ( $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/addon_fantastico.cgi' ) )
                    {
                        $Command = 'cp ' . $Constants['cp']['Options'] . ' ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/addon_fantastico.cgi ' . realpath ( $Constants['Paths']['WHM']['Fantastico_De_Luxe'] . '../' ) ;
                        $Output = Get_Output ( $Command , 'On' ) ;
                    }
                    $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/fantastico' ;
                    $Output = Get_Output ( $Command , 'On' ) ;
                    $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/installer' ;
                    $Output = Get_Output ( $Command , 'On' ) ;
                    $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/addon_fantastico.cgi' ;
                    $Output = Get_Output ( $Command , 'On' ) ;
                }
                else if ( eregi ( $Constants['wget']['Forbidden'] , $wget['Output'] ) )
                {
//----------------------------------------------------------------------------//
?>
        <h1 class="Failure No_Padding"><?php echo Get_Message ( 'This server is not properly licensed.' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Your main server IP as currently seen by our servers is %s.%sIf you have submitted a different IP for licensing, please contact your NOC if this is a NOC license or email %s with order number, currently licensed IP and new IP (%s) if this is a self-purchased license.%sIf this is a self-purchased license, it may also have expired. In this case, please follow the payment link in the renewal notification which you have received by email in order to renew your license.%sIf you ran a demo version of Fantastico, you now need to %spurchase a full license.%s' , Array ( '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<a href="mailto:sales@netenberg.com">sales@netenberg.com</a>' , '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<br/>' , '<a href="http://netenberg.com/shop/" target="_blank">' , '</a>' ) ) ; ?>
        </p>
</div>
<?php
//----------------------------------------------------------------------------//
                    $Stop = 1 ;
//----------------------------------------------------------------------------//
                }
                else if ( eregi ( $Constants['wget']['Service_Unavailable'] , $wget['Output'] ) )
                {
//----------------------------------------------------------------------------//
?>
        <h1 class="Failure No_Padding"><?php echo Get_Message ( 'Installation is currently not possible. Please retry later.' ) ; ?></h1>
</div>
<?php
//----------------------------------------------------------------------------//
                    $Stop = 1 ;
//----------------------------------------------------------------------------//
                }
                else
                {
//----------------------------------------------------------------------------//
?>
        <h1 class="Failure No_Padding"><?php echo Get_Message ( 'Installation is currently not possible. Please retry later.' ) ; ?></h1>
</div>
<?php
//----------------------------------------------------------------------------//
                    $Stop = 1 ;
//----------------------------------------------------------------------------//
                }
//----------------------------------------------------------------------------//
                if ( $Stop == 0 )
                {
//----------------------------------------------------------------------------//
                    foreach ( $Selected_Themes as $Key => $Value )
                    {
                        if ( '.' != $Value AND '..' != $Value AND is_dir ( $Constants['Paths']['cPanel']['Themes'] . $Value ) )
                        {
                            $Command = 'ln -s ' . $Public_Settings['Paths']['cPanel']['Fantastico_De_Luxe'] . ' ' . $Constants['Paths']['cPanel']['Themes'] . $Value ;
                            $Output = Get_Output ( $Command , 'On' ) ;
                        }
                    }
                    foreach ( $Themes as $Key => $Value )
                    {
                        if ( '.' != $Value AND '..' != $Value AND eregi ( "^rv" , $Value ) AND is_dir ( $Constants['Paths']['cPanel']['Themes'] . $Value ) )
                        {
                            $Command = 'ln -s ' . $Public_Settings['Paths']['cPanel']['Fantastico_De_Luxe'] . ' ' . $Constants['Paths']['cPanel']['Themes'] . $Value ;
                            $Output = Get_Output ( $Command , 'On' ) ;
                        }
                    }
//----------------------------------------------------------------------------//
                    $RVskin_Is_Installed = FALSE ;
                    foreach ( $Users As $User )
                    {
                        if ( eregi ( "^rv" , $User ) )
                        {
                            $Command = 'perl /root/rvadmin/fantasticopatch.pl' ;
                            $Output  = Get_Output ( $Command , 'On' ) ;
                            $RVskin_Is_Installed = TRUE ;
                        }
                    }
//----------------------------------------------------------------------------//
                    foreach ( $Scripts As $Key => $Script )
                    {
//------------------------------------------------------------------------------//
                        if ( !in_array ( $Script , $Deprecated_Scripts ) )
                        {
//------------------------------------------------------------------------------//
                            $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' . Get_tgz_Prefix ( ) . $Script . '.tgz' ;
                            $Output  = Get_Output ( $Command , 'On' ) ;
//------------------------------------------------------------------------------//
                            $wget = wget ( Get_tgz_Prefix ( ) . $Script . '.tgz' , $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' , 'Yes' ) ;
//------------------------------------------------------------------------------//
                            if ( eregi ( $Constants['wget']['Saved'] , $wget['Output'] ) OR eregi ( $Constants['wget']['No_Newer'] , $wget['Output'] ) )
                            {
//------------------------------------------------------------------------------//
?>
        <p class="No_Padding">
            <?php echo Get_Message ( '%s has been fetched.' , Array ( '<span class="Success"><strong>' . get_new_name ( $Script ) . '</strong></span>' ) ) ; ?>
        </p>
<?php
//------------------------------------------------------------------------------//
                            }
                            else if ( eregi ( $Constants['wget']['Forbidden'] , $wget['Output'] ) )
                            {
//------------------------------------------------------------------------------//
?>
        <h1 class="Failure No_Padding"><?php echo Get_Message ( 'This server is not properly licensed.' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Your main server IP as currently seen by our servers is %s.%sIf you have submitted a different IP for licensing, please contact your NOC if this is a NOC license or email %s with order number, currently licensed IP and new IP (%s) if this is a self-purchased license.%sIf this is a self-purchased license, it may also have expired. In this case, please follow the payment link in the renewal notification which you have received by email in order to renew your license.%sIf you ran a demo version of Fantastico, you now need to %spurchase a full license.%s' , Array ( '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<a href="mailto:sales@netenberg.com">sales@netenberg.com</a>' , '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<br/>' , '<a href="http://netenberg.com/shop/" target="_blank">' , '</a>' ) ) ; ?>
        </p>
<?php
//------------------------------------------------------------------------------//
                                $Stop = 1 ;
                                break ;
                            }
                            else if ( eregi ( $Constants['wget']['Service_Unavailable'] , $wget['Output'] ) )
                            {
//------------------------------------------------------------------------------//
?>
        <h1 class="Failure<?php echo ( 1 != $Key ) ? '' : ' No_Padding' ; ?>"><?php echo Get_Message ( 'Installation is currently not possible. Please retry later.' ) ; ?></h1>
<?php
//------------------------------------------------------------------------------//
                                $Stop = 1 ;
                                break ;
                            }
                            else
                            {
?>
        <h1 class="No_Padding"><?php echo Get_Message ( 'wget Error' ) ; ?></h1>
<?php
                                echo Get_Error ( $wget['Command'] , $wget['Output'] ) ;
                                $Stop = 1 ;
                                break ;
                            }
//------------------------------------------------------------------------------//
                            $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' . Get_tgz_Prefix ( ) . $Script . '.ini' ;
                            $Output  = Get_Output ( $Command , 'On' ) ;
//------------------------------------------------------------------------------//
                            $wget = wget ( Get_tgz_Prefix ( ) . $Script . '.ini' , $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' , 'Yes' ) ;
//------------------------------------------------------------------------------//
                            if ( eregi ( $Constants['wget']['Saved'] , $wget['Output'] ) OR eregi ( $Constants['wget']['No_Newer'] , $wget['Output'] ) )
                            {
//------------------------------------------------------------------------------//
?>
        <p class="No_Padding">
            <?php echo Get_Message ( '%s support file has been fetched.' , Array ( '<span class="Success"><strong>' . get_new_name ( $Script ) . '</strong></span>' ) ) ; ?>
        </p>
<?php
//------------------------------------------------------------------------------//
                            }
                            else if ( eregi ( $Constants['wget']['Forbidden'] , $wget['Output'] ) )
                            {
//------------------------------------------------------------------------------//
?>
        <h1 class="Failure No_Padding"><?php echo Get_Message ( 'This server is not properly licensed.' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Your main server IP as currently seen by our servers is %s.%sIf you have submitted a different IP for licensing, please contact your NOC if this is a NOC license or email %s with order number, currently licensed IP and new IP (%s) if this is a self-purchased license.%sIf this is a self-purchased license, it may also have expired. In this case, please follow the payment link in the renewal notification which you have received by email in order to renew your license.%sIf you ran a demo version of Fantastico, you now need to %spurchase a full license.%s' , Array ( '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<a href="mailto:sales@netenberg.com">sales@netenberg.com</a>' , '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<br/>' , '<a href="http://netenberg.com/shop/" target="_blank">' , '</a>' ) ) ; ?>
        </p>
<?php
//------------------------------------------------------------------------------//
                                $Stop = 1 ;
                                break ;
                            }
                            else if ( eregi ( $Constants['wget']['Service_Unavailable'] , $wget['Output'] ) )
                            {
//------------------------------------------------------------------------------//
?>
        <h1 class="Failure<?php echo ( 1 != $Key ) ? '' : ' No_Padding' ; ?>"><?php echo Get_Message ( 'Installation is currently not possible. Please retry later.' ) ; ?></h1>
<?php
//------------------------------------------------------------------------------//
                                $Stop = 1 ;
                                break ;
                            }
                            else
                            {
?>
        <h1 class="No_Padding"><?php echo Get_Message ( 'wget Error' ) ; ?></h1>
<?php
                                echo Get_Error ( $wget['Command'] , $wget['Output'] ) ;
                                $Stop = 1 ;
                                break ;
                            }
//------------------------------------------------------------------------------//
                        }
//------------------------------------------------------------------------------//
                    }
//----------------------------------------------------------------------------//
                    if ( 0 == $Stop )
                    {
//----------------------------------------------------------------------------//
                        if ( $Automatically_Activate_Scripts == 'Yes' )
                        {
                            foreach ( $Scripts as $Script )
                            {
                                if ( !in_array ( $Script , $Deprecated_Scripts ) )
                                {
                                    if ( !is_dir ( $Public_Settings['Paths']['Netenberg'] . 'netenberg/features_sets/sets/default/' . $Script ) AND !is_dir ( $Public_Settings['Paths']['Netenberg'] . 'netenberg/features_sets/sets/default/' . $Script . '.off' ) )
                                    {
                                        $Command = 'mkdir ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/features_sets/sets/default/' . $Script ;
                                        $Output  = Get_Output ( $Command , 'On' ) ;
                                    }
                                }
                            }
                        }
//----------------------------------------------------------------------------//
                        $Temporary = Set_Private_Settings ( $Private_Settings ) ;
//----------------------------------------------------------------------------//
                        $Temporary = Set_Public_Settings ( $Public_Settings ) ;
//----------------------------------------------------------------------------//
                        $Temporary = Set_Fantastico_De_Luxe_WHM_Admin_Public_Settings ( $Public_Settings ) ;
//----------------------------------------------------------------------------//
                        $Command = 'chown -R ' . Get_Owner ( ) . ':' . Get_Group ( ) . ' ' . $Public_Settings['Paths']['cPanel']['Fantastico_De_Luxe'] ;
                        $Output  = Get_Output ( $Command , 'On' ) ;
//----------------------------------------------------------------------------//
                        $Command = 'chown -R ' . Get_Owner ( ) . ':' . Get_Group ( ) . ' ' . $Constants['Paths']['WHM']['Fantastico_De_Luxe'] ;
                        $Output  = Get_Output ( $Command , 'On' ) ;
//----------------------------------------------------------------------------//
                        $Command = 'chown -R ' . Get_Owner ( ) . ':' . Get_Group ( ) . ' ' . realpath ( $Constants['Paths']['WHM']['Fantastico_De_Luxe'] . '../' ) . '/addon_fantastico.cgi' ;
                        $Output  = Get_Output ( $Command , 'On' ) ;
//----------------------------------------------------------------------------//
                        if ( !is_dir ( $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/installed/' ) )
                        {
                            $Command = 'mkdir ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/installed/'  ;
                            $Output  = Get_Output ( $Command , 'On' ) ;
                        }
//----------------------------------------------------------------------------//
                        $Temporary = Set_x_x2 ( ) ;
//----------------------------------------------------------------------------//
                        $Temporary = Delete_Cron ( $Constants['Paths']['WHM']['Fantastico_De_Luxe'] . 'scripts/' ) ;
                        $Temporary = Add_Cron    ( intval ( date ( 'i' ) ) . ' ' . date ( 'G' ) . ' * * * cd ' . $Constants['Paths']['WHM']['Fantastico_De_Luxe'] . 'scripts/ ; /usr/local/cpanel/3rdparty/bin/php cron.php > /dev/null 2>&1' . "\n" ) ;
//----------------------------------------------------------------------------//
?>
    <h1><?php echo Get_Message ( 'All necessary files have been fetched.' ) ; ?>

    <h1><?php echo Get_Message ( 'Please visit the links below in order to complete installation (all links will open in a new window).' ) ; ?></h1>
    <p>
        <?php echo Get_Message ( '%sClick here%s in order to activate Fantastico in the WHM Features Manager.' , Array ( '<a href="' . $_ENV['cp_security_token'] . '/scripts2/dofeaturemanager?action=editfeature&feature=default" target="_blank"><strong>' , '</strong></a>' ) ) ; ?>
    </p>
    <p>
        <?php echo Get_Message ( '%sClick here%s in order to open the Fantastico De Luxe WHM Admin (Settings page) and configure Fantastico or it may not work properly.' , Array ( '<a href="' . $Constants['URLs']['WHM']['Fantastico_De_Luxe'] . 'fantastico.php?Primary_Action=Settings&Secondary_Action=Edit"><strong>' , '</strong></a>' ) ) ; ?>
    </p>
<?php
//----------------------------------------------------------------------------//
                        if ( TRUE == $RVskin_Is_Installed )
                        {
//----------------------------------------------------------------------------//
?>
    <h1><?php echo Get_Message ( 'Also do not forget to activate Fantastico in the RVSkin administration!' ) ; ?></h1>
<?php

//----------------------------------------------------------------------------//
                        }
//----------------------------------------------------------------------------//
?>
    <h1><?php echo Get_Message ( 'Thank you for using Fantastico De Luxe!' ) ; ?></h1>
</div>
<?php

//----------------------------------------------------------------------------//
                    }
                    else
                    {
?>
</div>
<?php
                    }
//----------------------------------------------------------------------------//
                }
//----------------------------------------------------------------------------//
            }
//----------------------------------------------------------------------------//
        }
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
?>
