<?php
//----------------------------------------------------------------------------//
    function clean_up(){
        $var = $GLOBALS['Public_Settings']['Paths']['Netenberg'];
        $whm = $GLOBALS['Constants']['Paths']['WHM']['Fantastico_De_Luxe'];
        $cpanel = $GLOBALS['Public_Settings']['Paths']['cPanel']['Fantastico_De_Luxe'];

        $files = array();

        $files[] = sprintf('%snetenberg/fantastico_de_luxe/kanoodle/public_settings.php', $var);

        $files[] = sprintf('%sactions/kanoodle.php', $whm);
        $files[] = sprintf('%skanoodle/kanoodle.pl', $whm);

        $files[] = sprintf('%sincludes/enc_kanoodle_post.php', $cpanel);
        $files[] = sprintf('%sincludes/enc_kanoodle_pre.php', $cpanel);
        $files[] = sprintf('%skanoodle.php', $cpanel);
        $files[] = sprintf('%skanoodle/', $cpanel);
        $files[] = sprintf('%spopup.php', $cpanel);

        if($files){
            foreach($files as $file){
                /*
                if(@is_file($file)){
                    @unlink($file);
                }else{
                }
                */
                $command = sprintf('rm -rf %s 2>&1', escapeshellarg($file));
                exec($command, $output, $return_var);
                // echo Get_Variable_Dump($command."\n");
                // echo Get_Variable_Dump($output);
                // echo Get_Variable_Dump($return_var);
            }
        }else{
        }
    }
//----------------------------------------------------------------------------//
    function parse_oin ( $file )
    {
        $variables = array
        (
            'OIN' => '' ,
        ) ;
        $contents = file_get_contents ( $file ) ;
        $contents = preg_replace ( "#\n#" , '' , $contents ) ;
        if ( count ( $variables ) )
        {
            foreach ( $variables as $key => $variable )
            {
                preg_match_all ( '#[$]' . preg_quote ( $key ) . '\s*=\s*([^\'"]*)#' , $contents , $matches , PREG_SET_ORDER ) ;
                $variables[$key] = intval ( $matches[0][1] ) ;
            }
        }
        else
        {
        }
        return array ( $variables['OIN'] ) ;
    }
//----------------------------------------------------------------------------//
    function parse_user_email ( $file )
    {
        $variables = array
        (
            'user_email' => '' ,
        ) ;
        $contents = file_get_contents ( $file ) ;
        $contents = preg_replace ( "#\n#" , '' , $contents ) ;
        if ( count ( $variables ) )
        {
            foreach ( $variables as $key => $variable )
            {
                preg_match_all ( '#[$]' . preg_quote ( $key ) . '\s*=\s*[\'"]([^\'"]*)[\'"]#' , $contents , $matches , PREG_SET_ORDER ) ;
                $variables[$key] = $matches[0][1] ;
            }
        }
        else
        {
        }
        return array ( $variables['user_email'] ) ;
    }
//----------------------------------------------------------------------------//
    function parse_fantversion ( $file )
    {
        $variables = array
        (
            'version' => '' ,
        ) ;
        $contents = file_get_contents ( $file ) ;
        $contents = preg_replace ( "#\n#" , '' , $contents ) ;
        if ( count ( $variables ) )
        {
            foreach ( $variables as $key => $variable )
            {
                preg_match_all ( '#[$]' . preg_quote ( $key ) . '\s*=\s*[\'"]([^\'"]*)[\'"]#' , $contents , $matches , PREG_SET_ORDER ) ;
                $variables[$key] = $matches[0][1] ;
            }
        }
        else
        {
        }
        return array ( $variables['version'] ) ;
    }
//----------------------------------------------------------------------------//
    function parse_registry ( $file )
    {
        $variables = array
        (
            'thisdb'         => '' ,
            'thisdomain'     => '' ,
            'thisscriptpath' => '' ,
        ) ;
        $contents = file_get_contents ( $file ) ;
        $contents = preg_replace ( "#\n#" , '' , $contents ) ;
        if ( count ( $variables ) )
        {
            foreach ( $variables as $key => $variable )
            {
                preg_match_all ( '#[$]' . preg_quote ( $key ) . '\s*=\s*[\'"]([^\'"]*)[\'"]#' , $contents , $matches , PREG_SET_ORDER ) ;
                $variables[$key] = $matches[0][1] ;
            }
        }
        else
        {
        }
        return array ( $variables['thisdb'] , $variables['thisdomain'] , $variables['thisscriptpath'] ) ;
    }
//----------------------------------------------------------------------------//
    function get_new_name ( $old_name )
    {
        $old_name = str_replace ( '_' , ' ' , $old_name ) ;
        switch ( $old_name )
        {
            case 'Mambo Open Source' : $new_name = 'Mambo'                  ; break ;
            case 'TikiWiki'          : $new_name = 'TikiWiki CMS/Groupware' ; break ;
            case 'phpBB2'            : $new_name = 'phpBB'                  ; break ;
            case 'phpAdsNew'         : $new_name = 'OpenX'                  ; break ;
            case 'Post-Nuke'         : $new_name = 'Zikula'                 ; break ;
            case 'Joomla 1.6'        : $new_name = 'Joomla 1.7'             ; break ;
            default                  : $new_name = $old_name                ;
        }
        return $new_name ;
    }
//----------------------------------------------------------------------------//
    function _Get_Sanitized_String ( $Array )
    {
        if ( is_array ( $Array ) )
        {
            foreach ( $Array As $Key => $Value )
            {
                $Array[$Key] = _Get_Sanitized_String ( $Value ) ;
            }
        }
        else
        {
            $Array = Get_Sanitized_String ( $Array ) ;
        }
        return $Array ;
    }
//----------------------------------------------------------------------------//
    function _stripslashes ( $Array )
    {
        if ( is_array ( $Array ) )
        {
            foreach ( $Array As $Key => $Value )
            {
                $Array[$Key] = _stripslashes ( $Value ) ;
            }
        }
        else
        {
            $Array = stripslashes ( $Array ) ;
        }
        return $Array ;
    }
//----------------------------------------------------------------------------//
    function Set_cron_Templates ( $Templates )
    {

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/oin/host/subject' ;
        $Contents = $Templates['oin']['Host']['Subject'] ;
        $Contents = trim ( $Contents ) ;
        $Temporary = Set_Files_Add ( $File , 'w' , $Contents ) ;
        $Temporary = chmod ( $File , 0600 ) ;

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/oin/users/subject' ;
        $Contents = $Templates['oin']['Users']['Subject'] ;
        $Contents = trim ( $Contents ) ;
        $Temporary = Set_Files_Add ( $File , 'w' , $Contents ) ;
        $Temporary = chmod ( $File , 0600 ) ;

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/un/host/subject' ;
        $Contents = $Templates['un']['Host']['Subject'] ;
        $Contents = trim ( $Contents ) ;
        $Temporary = Set_Files_Add ( $File , 'w' , $Contents ) ;
        $Temporary = chmod ( $File , 0600 ) ;

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/oin/host/body' ;
        $Contents = $Templates['oin']['Host']['Body'] ;
        $Contents = trim ( $Contents ) ;
        $Temporary = Set_Files_Add ( $File , 'w' , $Contents ) ;
        $Temporary = chmod ( $File , 0600 ) ;

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/oin/users/body' ;
        $Contents = $Templates['oin']['Users']['Body'] ;
        $Contents = trim ( $Contents ) ;
        $Temporary = Set_Files_Add ( $File , 'w' , $Contents ) ;
        $Temporary = chmod ( $File , 0600 ) ;

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/un/host/body' ;
        $Contents = $Templates['un']['Host']['Body'] ;
        $Contents = trim ( $Contents ) ;
        $Temporary = Set_Files_Add ( $File , 'w' , $Contents ) ;
        $Temporary = chmod ( $File , 0600 ) ;

        return TRUE ;

    }
//----------------------------------------------------------------------------//
    function Get_cron_Templates ( )
    {

        $Templates = Array ( ) ;

        $Templates['oin'] = Array ( ) ;

        $Templates['oin']['Host']['Subject'] = 'Fantastico De Luxe Outdated Installations Notification for [[[_HOSTNAME_]]] ([[[_IP_ADDRESS_]]])' ;
        $Contents = <<<EOD
Server: [[[_HOSTNAME_]]] ([[[_IP_ADDRESS_]]])

Date/Time: [[[_DATE_AND_TIME_]]]

The following installations are not up-to-date:

[[[_NOTIFICATION_]]]
EOD;
        $Templates['oin']['Host']['Body'] = $Contents ;

        $Templates['oin']['Users']['Subject'] = 'Fantastico De Luxe Outdated Installations Notification for [[[_DOMAIN_NAME_]]] on [[[_HOSTNAME_]]] ([[[_IP_ADDRESS_]]])' ;
        $Contents = <<<EOD
Domain Name: [[[_DOMAIN_NAME_]]]

Server: [[[_HOSTNAME_]]] ([[[_IP_ADDRESS_]]])

Date/Time: [[[_DATE_AND_TIME_]]]

The following installations are not up-to-date:

[[[_NOTIFICATION_]]]
EOD;
        $Templates['oin']['Users']['Body'] = $Contents ;

        $Templates['un'] = Array ( ) ;

        $Templates['un']['Host']['Subject'] = 'Fantastico De Luxe Updates Notification for [[[_HOSTNAME_]]] ([[[_IP_ADDRESS_]]])' ;
        $Contents = <<<EOD
Server: [[[_HOSTNAME_]]] ([[[_IP_ADDRESS_]]])

Date/Time: [[[_DATE_AND_TIME_]]]

[[[_NOTIFICATION_]]]
EOD;
        $Templates['un']['Host']['Body'] = $Contents ;

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/oin/host/subject' ;
        if ( TRUE === is_file ( $File ) )
        {
            $Contents = file_get_contents ( $File ) ;
            if ( TRUE === empty ( $Contents ) )
            {
            }
            else
            {
                $Templates['oin']['Host']['Subject'] = $Contents ;
            }
        }
        else
        {
        }

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/oin/users/subject' ;
        if ( TRUE === is_file ( $File ) )
        {
            $Contents = file_get_contents ( $File ) ;
            if ( TRUE === empty ( $Contents ) )
            {
            }
            else
            {
                $Templates['oin']['Users']['Subject'] = $Contents ;
            }
        }
        else
        {
        }

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/un/host/subject' ;
        if ( TRUE === is_file ( $File ) )
        {
            $Contents = file_get_contents ( $File ) ;
            if ( TRUE === empty ( $Contents ) )
            {
            }
            else
            {
                $Templates['un']['Host']['Subject'] = $Contents ;
            }
        }
        else
        {
        }

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/oin/host/body' ;
        if ( TRUE === is_file ( $File ) )
        {
            $Contents = file_get_contents ( $File ) ;
            if ( TRUE === empty ( $Contents ) )
            {
            }
            else
            {
                $Templates['oin']['Host']['Body'] = $Contents ;
            }
        }
        else
        {
        }

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/oin/users/body' ;
        if ( TRUE === is_file ( $File ) )
        {
            $Contents = file_get_contents ( $File ) ;
            if ( TRUE === empty ( $Contents ) )
            {
            }
            else
            {
                $Templates['oin']['Users']['Body'] = $Contents ;
            }
        }
        else
        {
        }

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/templates/un/host/body' ;
        if ( TRUE === is_file ( $File ) )
        {
            $Contents = file_get_contents ( $File ) ;
            if ( TRUE === empty ( $Contents ) )
            {
            }
            else
            {
                $Templates['un']['Host']['Body'] = $Contents ;
            }
        }
        else
        {
        }

        $Temporary = Set_cron_Templates ( $Templates ) ;

        return $Templates ;

    }
//----------------------------------------------------------------------------//
    function Set_Files_Add ( $File , $Mode , $Contents )
    {
        $Temporary = clearstatcache ( ) ;
        $Handle = fopen ( $File , $Mode ) ;
        if ( FALSE === $Handle )
        {
        }
        else
        {
            $Temporary = fwrite ( $Handle , $Contents ) ;
            $Temporary = fclose ( $Handle             ) ;
        }
        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Set_OIN_Settings ( $OIN )
    {

        if ( TRUE === is_array ( $OIN['Exclusions']['Domain_Names'] ) )
        {
            $OIN['Exclusions']['Domain_Names'] = implode ( ',' , $OIN['Exclusions']['Domain_Names'] ) ;
        }
        else
        {
            $OIN['Exclusions']['Domain_Names'] = NULL ;
        }

        if ( TRUE === is_array ( $OIN['Exclusions']['User_Names'] ) )
        {
            $OIN['Exclusions']['User_Names'] = implode ( ',' , $OIN['Exclusions']['User_Names'] ) ;
        }
        else
        {
            $OIN['Exclusions']['User_Names'] = NULL ;
        }

        $Contents = <<<EOD

[Exclusions]
Domain_Names = "{$OIN['Exclusions']['Domain_Names']}"
User_Names   = "{$OIN['Exclusions']['User_Names']}"

[Others]
E_Mail_Address = "{$OIN['Others']['E_Mail_Address']}"

[Statuses]
Host  = "{$OIN['Statuses']['Host']}"
Users = "{$OIN['Statuses']['Users']}"
EOD;

        $Contents = trim ( $Contents ) ;

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/settings/oin.ini' ;
        $Temporary = Set_Files_Add ( $File , 'w' , $Contents ) ;
        $Temporary = chmod ( $File , 0600 ) ;

        return TRUE ;

    }
//----------------------------------------------------------------------------//
    function Get_OIN_Settings ( )
    {

        $File = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cron/settings/oin.ini' ;

        if ( is_file ( $File ) )
        {
            $OIN = parse_ini_file ( $File , TRUE ) ;
        }

        if ( empty ( $OIN['Exclusions']['Domain_Names'] ) )
        {
            $OIN['Exclusions']['Domain_Names'] = Array ( ) ;
        }
        else
        {
            $OIN['Exclusions']['Domain_Names'] = explode ( ',' , $OIN['Exclusions']['Domain_Names'] ) ;
        }

        if ( empty ( $OIN['Exclusions']['User_Names'] ) )
        {
            $OIN['Exclusions']['User_Names'] = Array ( ) ;
        }
        else
        {
            $OIN['Exclusions']['User_Names'] = explode ( ',' , $OIN['Exclusions']['User_Names'] ) ;
        }

        if ( empty ( $OIN['Others']['E_Mail_Address'] ) )
        {
            $OIN['Others']['E_Mail_Address'] = NULL ;
        }

        if ( empty ( $OIN['Statuses']['Host'] ) )
        {
            $OIN['Statuses']['Host'] = 'On' ;
        }

        if ( empty ( $OIN['Statuses']['Users'] ) )
        {
            $OIN['Statuses']['Users'] = 'On' ;
        }

        $Temporary = Set_OIN_Settings ( $OIN ) ;

        return $OIN ;

    }
//----------------------------------------------------------------------------//
    function Set_Mail ( $From , $To , $Subject , $Body , $CC , $BCC )
    {

        $PHPMailer = new PHPMailer ( ) ;

        $PHPMailer->CharSet     = 'utf-8'      ;
        $PHPMailer->ContentType = 'text/plain' ;
        $PHPMailer->Mailer      = 'mail'       ;
        $PHPMailer->Priority    = 1            ;
        $PHPMailer->WordWrap    = 72           ;

        $PHPMailer->From     = $From ;
        $PHPMailer->FromName = NULL  ;
        $PHPMailer->Sender   = $From ;

        $PHPMailer->Subject = $Subject ;
        $PHPMailer->Body    = $Body    ;

        $PHPMailer->AddReplyTo ( $From ) ;

        $PHPMailer->IsHTML ( FALSE ) ;

        $PHPMailer->IsMail ( ) ;

        $PHPMailer->SetLanguage ( 'en' , '/usr/local/cpanel/whostmgr/docroot/cgi/fantastico/libraries/PHPMailer/language/' ) ;

        if ( !empty ( $To ) )
        {
            foreach ( $To As $Key => $Value )
            {
                $PHPMailer->AddAddress ( $Value ) ;
            }
        }
        if ( !empty ( $CC ) )
        {
            foreach ( $CC As $Key => $Value )
            {
                $PHPMailer->AddCC ( $Value ) ;
            }
        }
        if ( !empty ( $BCC ) )
        {
            foreach ( $BCC As $Key => $Value )
            {
                $PHPMailer->AddBCC ( $Value ) ;
            }
        }

        $Status = $PHPMailer->Send ( ) ;

        // echo "\n" . str_repeat ( '-' , 80 ) . "\n" ;
        // echo $From ;
        // echo "\n" . str_repeat ( '-' , 80 ) . "\n" ;
        // echo implode ( ',' , $To ) ;
        // echo "\n" . str_repeat ( '-' , 80 ) . "\n" ;
        // echo $Subject ;
        // echo "\n" . str_repeat ( '-' , 80 ) . "\n" ;
        // echo $Body ;
        // echo "\n" . str_repeat ( '-' , 80 ) . "\n" ;

        return TRUE ;

    }
//----------------------------------------------------------------------------//
    function Get_x3_Status ( )
    {
        $Status = 'Off' ;
        if ( @is_file ( '/usr/local/cpanel/bin/register_cpanelplugin' ) OR @is_file ( '/usr/local/cpanel/bin/register_cpaneladdonmodule' ) )
        {
            $Status = 'On' ;
        }
        return $Status ;
    }
//----------------------------------------------------------------------------//
    function Set_x3 ( )
    {
        if ( 'On' == Get_x3_Status ( ) )
        {
            if ( is_dir ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x/' ) )
            {
                if ( !is_dir ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x/cells/' ) )
                {
                    $Command = "mkdir -p {$GLOBALS['Constants']['Paths']['cPanel']['Themes']}x/cells/" ;
                    $Output  = Get_Output ( $Command , 'On' ) ;

                    $Command = "chmod 755 {$GLOBALS['Constants']['Paths']['cPanel']['Themes']}x/cells/" ;
                    $Output  = Get_Output ( $Command , 'On' ) ;
                }
                if ( !is_link ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells' ) )
                {
                    $Command = 'ln -s ' . $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x/cells ' . $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells' ;
                    $Output = Get_Output ( $Command , 'On' ) ;
                }
            }
            else
            {
                if ( is_dir ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/' ) )
                {
                    if ( is_link ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells' ) )
                    {
                        $Command = 'rm -rf ' . $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells' ;
                        $Output  = Get_Output ( $Command , 'On' ) ;
                    }
                    if ( !is_dir ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells/' ) )
                    {
                        $Command = "mkdir -p {$GLOBALS['Constants']['Paths']['cPanel']['Themes']}x2/cells/" ;
                        $Output  = Get_Output ( $Command , 'On' ) ;

                        $Command = "chmod 755 {$GLOBALS['Constants']['Paths']['cPanel']['Themes']}x2/cells/" ;
                        $Output  = Get_Output ( $Command , 'On' ) ;
                    }
                }
            }
            $fantastico_html = $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x/cells/fantastico.html' ;
            if ( is_file ( $fantastico_html ) )
            {
                $Command = 'rm -f ' . $fantastico_html ;
                $Output  = Get_Output ( $Command , 'Off' ) ;
            }
            $fantastico_html = $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells/fantastico.html' ;
            if ( is_file ( $fantastico_html ) )
            {
                $Command = 'rm -f ' . $fantastico_html ;
                $Output  = Get_Output ( $Command , 'Off' ) ;
            }
            $Temporary = $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x3' ;
            if ( !is_link ( $Temporary . '/fantastico' ) )
            {
                $Command = 'ln -s ' . $GLOBALS['Public_Settings']['Paths']['cPanel']['Fantastico_De_Luxe'] . ' ' . $Temporary ;
                $Output  = Get_Output ( $Command , 'Off' ) ;
            }
            if ( is_link ( $Temporary . '/fantastico' ) )
            {
                $Contents = <<<EOC
name:Fantastico_De_Luxe
description:Fantastico De Luxe
featuremanager:1
if:
itemdesc:Fantastico De Luxe
itemorder:999
url:fantastico/index.php
group:software
image:iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAIAAAD8GO2jAAAABGdBTUEAAK/INwWK6QAAABl0RVh0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EOC;
                $Contents = trim ( $Contents ) ;
                $cpaneladdonmodule = '/usr/local/cpanel/bin/fantastico_de_luxe.cpaneladdonmodule' ;
                $Handle = fopen  ( $cpaneladdonmodule , 'w' ) ;
                if ( TRUE == $Handle )
                {
                    $Temporary = fwrite ( $Handle , $Contents ) ;
                    $Temporary = fclose ( $Handle             ) ;
                    $Command = 'chmod 755 ' . $cpaneladdonmodule ;
                    $Output  = Get_Output ( $Command , 'Off' ) ;
                    if ( is_file ( '/usr/local/cpanel/bin/register_cpanelplugin' ) )
                    {
                        $Command = '/usr/local/cpanel/bin/register_cpanelplugin ' . $cpaneladdonmodule ;
                        $Output  = Get_Output ( $Command , 'Off' ) ;
                    }
                    else if ( is_file ( '/usr/local/cpanel/bin/register_cpaneladdonmodule' ) )
                    {
                        $Command = '/usr/local/cpanel/bin/register_cpaneladdonmodule ' . $cpaneladdonmodule ;
                        $Output  = Get_Output ( $Command , 'Off' ) ;
                    }
                    $Command = '/usr/local/cpanel/bin/rebuild_sprites' ;
                    $Output  = Get_Output ( $Command , 'Off' ) ;
                }
            }
        }
        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Get_Owner ( )
    {
        $Owner = 'root' ;
        switch ( PHP_OS )
        {
            case 'Linux' :
                $Owner = 'root' ;
                break ;
            case 'FreeBSD' :
                $Owner = 'root' ;
                break ;
        }
        return $Owner ;
    }
//----------------------------------------------------------------------------//
    function Get_Group ( )
    {
        $Group = 'root' ;
        switch ( PHP_OS )
        {
            case 'Linux' :
                $Group = 'root' ;
                break ;
            case 'FreeBSD' :
                $Group = 'wheel' ;
                break ;
        }
        return $Group ;
    }
//----------------------------------------------------------------------------//
    function Set_Clean_Up_Pre_Post_Scripts ( )
    {
        $Directory = '/usr/local/cpanel/whostmgr/docroot/cgi/fantastico/scripts/' ;
        $Files = Array
        (
            $Directory . 'pre_fantastico_de_luxe_upgrade.php'  => '7979836b950deb93783c51ff7a0ed800' ,
            $Directory . 'post_fantastico_de_luxe_upgrade.php' => 'c10300c6d8fdd8088ff15c6d42ae1837' ,
            $Directory . 'pre_scripts_upgrade.php'             => '6e611022410a8b153eb9ec68d9d225b1' ,
            $Directory . 'post_scripts_upgrade.php'            => '4c3736664b4031b25d76ee0af811fa2d' ,
        ) ;
        foreach ( $Files As $File => $md5 )
        {
            if ( is_file ( $File ) )
            {
                if ( md5 ( file_get_contents ( $File ) ) == $md5 )
                {
                    $Command = 'rm -rf "' . $File . '"' ;
                    $Output  = Get_Output ( $Command ) ;
                }
            }
        }
        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Set_fantastico_html ( $File )
    {
        $Contents = <<<EOD
<cpanelfeature fantastico>
    <cpanelcell align="center" valign="top">
        <td width="75" nowrap>
            <a href="<cpanel printvar="dprefix">fantastico/index.php"><img border="0" src="<cpanel printvar="dprefix">fantastico/fantasticoimages/fantastico_small.gif" alt="Fantastico"></a>
            <br/>
            <br/>
            <a href="<cpanel printvar="dprefix">fantastico/index.php">Fantastico</a>
        </td>
    </cpanelcell>
</cpanelfeature>
EOD;
        $Contents = trim ( $Contents ) ;

        $Command = "{$GLOBALS['Constants']['Commands']['chattr']['Off']} $File" ;
        $Output  = Get_Output ( $Command ) ;

        $Handle = fopen ( $File , 'w' ) ;
        if ( TRUE == $Handle )
        {
            $Temporary = fwrite ( $Handle , $Contents ) ;
            $Temporary = fclose ( $Handle             ) ;
        }

        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Set_x_x2 ( )
    {
        if ( 'Off' == Get_x3_Status ( ) )
        {
            if ( is_dir ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x/' ) )
            {
                if ( !is_dir ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x/cells/' ) )
                {
                    $Command = "mkdir -p {$GLOBALS['Constants']['Paths']['cPanel']['Themes']}x/cells/" ;
                    $Output  = Get_Output ( $Command , 'On' ) ;

                    $Command = "chmod 755 {$GLOBALS['Constants']['Paths']['cPanel']['Themes']}x/cells/" ;
                    $Output  = Get_Output ( $Command , 'On' ) ;
                }
                $Temporary = Set_fantastico_html ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x/cells/fantastico.html' ) ;
                if ( !is_link ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells' ) )
                {
                    $Command = 'ln -s ' . $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x/cells ' . $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells' ;
                    $Output = Get_Output ( $Command , 'On' ) ;
                }
            }
            else
            {
                if ( is_dir ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/' ) )
                {
                    if ( is_link ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells' ) )
                    {
                        $Command = 'rm -rf ' . $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells' ;
                        $Output  = Get_Output ( $Command , 'On' ) ;
                    }
                    if ( !is_dir ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells/' ) )
                    {
                        $Command = "mkdir -p {$GLOBALS['Constants']['Paths']['cPanel']['Themes']}x2/cells/" ;
                        $Output  = Get_Output ( $Command , 'On' ) ;

                        $Command = "chmod 755 {$GLOBALS['Constants']['Paths']['cPanel']['Themes']}x2/cells/" ;
                        $Output  = Get_Output ( $Command , 'On' ) ;
                    }
                    $Temporary = Set_fantastico_html ( $GLOBALS['Constants']['Paths']['cPanel']['Themes'] . 'x2/cells/fantastico.html' ) ;
                }
            }
        }
        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Set_Fantastico_De_Luxe_WHM_Admin_Public_Settings ( $Public_Settings )
    {
        $Handle = fopen  ( '/usr/local/cpanel/whostmgr/docroot/cgi/fantastico/settings/public_settings.php' , 'w' ) ;
        if ( TRUE == $Handle )
        {
            $Temporary = fwrite ( $Handle , '<?php' . "\n" ) ;
            $Temporary = fwrite ( $Handle , '//----------------------------------------------------------------------------//'                         . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Paths\'][\'Netenberg\'] = \'' . $Public_Settings['Paths']['Netenberg'] . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , '//----------------------------------------------------------------------------//'                         . "\n" ) ;
            $Temporary = fwrite ( $Handle , '?>' ) ;
            $Temporary = fclose ( $Handle        ) ;
            $Command   = 'chmod 644 /usr/local/cpanel/whostmgr/docroot/cgi/fantastico/settings/public_settings.php' ;
            $Output    = Get_Output ( $Command ) ;
        }
    }
//----------------------------------------------------------------------------//
    function Set_Public_Settings ( $Public_Settings )
    {
        $Handle = fopen  ( $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/public_settings.php' , 'w' ) ;
        if ( TRUE == $Handle )
        {
            $Temporary = fwrite ( $Handle , '<?php' . "\n" ) ;
            $Temporary = fwrite ( $Handle , '//----------------------------------------------------------------------------//'                                                                                                                   . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Binaries\'          ][\'NetPBM\'            ]                         = \'' . $Public_Settings['Binaries'          ]['NetPBM'            ]                       . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Administrator\'     ][\'From\'              ]                         = \'' . $Public_Settings['Administrator'     ]['From'              ]                       . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Administrator\'     ][\'E_Mail_Address\'    ]                         = \'' . $Public_Settings['Administrator'     ]['E_Mail_Address'    ]                       . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Administrator\'     ][\'Username\'          ]                         = \'' . $Public_Settings['Administrator'     ]['Username'          ]                       . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Language\'          ]                                                 = \'' . $Public_Settings['Language'          ]                                             . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Licensing_Server\'  ]                                                 = \'' . $Public_Settings['Licensing_Server'  ]                                             . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'phpsuexec\'         ][\'Status\'            ]                         = \'' . $Public_Settings['phpsuexec'         ]['Status'            ]                       . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Fantastico_De_Luxe\'][\'Status\'            ]                         = \'' . $Public_Settings['Fantastico_De_Luxe']['Status'            ]                       . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Fantastico_De_Luxe\'][\'Update_To\'         ]                         = \'' . $Public_Settings['Fantastico_De_Luxe']['Update_To'         ]                       . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Paths\'             ][\'cPanel\'            ][\'Fantastico_De_Luxe\'] = \'' . $Public_Settings['Paths'             ]['cPanel'            ]['Fantastico_De_Luxe'] . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , '//----------------------------------------------------------------------------//'                                                                                                                   . "\n" ) ;
            $Temporary = fwrite ( $Handle , '?>' ) ;
            $Temporary = fclose ( $Handle        ) ;
            $Command   = 'chmod 644 ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/public_settings.php' ;
            $Output    = Get_Output ( $Command ) ;
        }
    }
//----------------------------------------------------------------------------//
    function Set_Private_Settings ( $Private_Settings )
    {
        $Handle = fopen  ( $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/private_settings.php' , 'w' ) ;
        if ( TRUE == $Handle )
        {
            $Temporary = fwrite ( $Handle , '<?php' . "\n" ) ;
            $Temporary = fwrite ( $Handle , '//----------------------------------------------------------------------------//'                                             . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Private_Settings[\'Binaries\' ][\'wget\'          ] = \'' . $Private_Settings['Binaries' ]['wget'          ] . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Private_Settings[\'Cron\'     ][\'E_Mail_Address\'] = \'' . $Private_Settings['Cron'     ]['E_Mail_Address'] . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Private_Settings[\'Debug\'    ][\'Status\'        ] = \'' . $Private_Settings['Debug'    ]['Status'        ] . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Private_Settings[\'Language\' ]                     = \'' . $Private_Settings['Language' ]                   . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Private_Settings[\'wget\'     ][\'Time_Out\'      ] = \'' . $Private_Settings['wget'     ]['Time_Out'      ] . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Private_Settings[\'VPS\'      ][\'Status\'        ] = \'' . $Private_Settings['VPS'      ]['Status'        ] . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , '//----------------------------------------------------------------------------//'                                             . "\n" ) ;
            $Temporary = fwrite ( $Handle , '?>' ) ;
            $Temporary = fclose ( $Handle        ) ;
            $Command   = 'chmod 600 ' . $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/private_settings.php' ;
            $Output    = Get_Output ( $Command ) ;
        }
    }
//----------------------------------------------------------------------------//
    function Get_Random_Licensing_Server ( )
    {

        /*

        $Temporary[0] = 'netenberg.com'         ;
        $Temporary[1] = 'files.status365.com'   ;
        $Temporary[2] = 'files.betaservant.com' ;
        $Temporary[3] = 'files.status365.com'   ;
        $Temporary[4] = 'files.betaservant.com' ;

        $X = rand ( 0 , 4 ) ;

        return $Temporary[$X] ;

        */

        return '174.120.165.106' ;

    }
//----------------------------------------------------------------------------//
    function Get_Partitions_List ( )
    {
        $Banned = Array
        (
            'boot'       ,
            'lost+found' ,
            'dev'        ,
            'proc'       ,
            'tmp'        ,
            'bin'        ,
            'initrd'     ,
            'sbin'       ,
            'usr'        ,
            'mnt'        ,
            'scripts'    ,
            'lib'        ,
            'root'       ,
        ) ;
        $Directories = Array ( ) ;
        $Temporary = Get_Files ( '/' ) ;
        natcasesort ( $Temporary ) ;
        foreach ( $Temporary As $Key => $Value )
        {
            if ( !in_array ( $Value , $Banned ) AND !ereg ( "^\." , $Value ) AND is_dir ( '/' . $Value ) )
            {
                $Size = round ( disk_free_space ( '/' . $Value ) / 1024 / 1024 / 1024 , 2 ) ;
                $Caption = Get_Message ( '%s (%s GB free)' , Array ( '/' . $Value . '/' , $Size ) ) ;
                $Directories[] = Array
                (
                    'Caption' => $Caption ,
                    'Value'   => $Value   ,
                ) ;
            }
        }
        return $Directories ;
    }
//----------------------------------------------------------------------------//
    function Get_License_Status ( )
    {

        $Status = 'Off' ;

        $Files['License'  ] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.license/.contents'  ;
        $Files['Timestamp'] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.license/.timestamp' ;

        if ( is_file ( $Files['License'] ) )
        {
            $License = trim ( file_get_contents ( $Files['License'] ) ) ;
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'License: Cached Contents:' ) ;
                echo Get_Variable_Dump ( $License                    ) ;
            }
            /* Debugging */
        }
        else
        {
            $License = '' ;
        }

        if ( is_file ( $Files['Timestamp'] ) )
        {
            $Timestamp = trim ( file_get_contents ( $Files['Timestamp'] ) ) ;
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'License: Cached Timestamp:' ) ;
                echo Get_Variable_Dump ( $Timestamp                   ) ;
            }
            /* Debugging */
        }
        else
        {
            $Timestamp = 0 ;
        }

        if ( !empty ( $License ) AND !empty ( $Timestamp ) )
        {
            if ( $Timestamp >= ( time ( ) - $GLOBALS['Cache']['Period'] ) )
            {
                $Status = 'On' ;
            }
        }

        $Status = 'Off' ;

        if ( 'Off' == $Status )
        {

            $Status = 'Unknown' ;
            $Result = '' ;
            $Socket = @fsockopen ( $GLOBALS['Public_Settings']['Licensing_Server'] , 80 , $Number , $String , 2 ) ;
            if ( TRUE == $Socket )
            {
                $Request  = '' ;
                $Request .= "GET /files/fantastico/license.php HTTP/1.1\r\n" ;
                $Request .= "Host: " . $GLOBALS['Public_Settings']['Licensing_Server'] . "\r\n" ;
                $Request .= "Connection: Close\r\n";
                $Request .= "\r\n";

                $Temporary = fputs ( $Socket , $Request ) ;
                $Result    = ''                           ;
                while ( !feof ( $Socket ) )
                {
                    $Result .= fgets ( $Socket , 4096 ) ;
                }
                $Temporary = fclose ( $Socket ) ;
            }

            if ( empty ( $Result ) )
            {
                foreach ( $GLOBALS['Constants']['Licensing_Servers'] As $Key => $Value )
                {
                    if ( $Key != $GLOBALS['Public_Settings']['Licensing_Server'] )
                    {
                        $Request = '' ;
                        $Result  = '' ;
                        $Socket  = @fsockopen ( $Key , 80 , $Number , $String , 2 ) ;
                        if ( TRUE == $Socket )
                        {
                            $Request .= "GET /files/fantastico/license.php HTTP/1.1\r\n" ;
                            $Request .= "Host: $Key\r\n" ;
                            $Request .= "Connection: Close\r\n";
                            $Request .= "\r\n";

                            $Temporary = fputs ( $Socket , $Request ) ;
                            $Result    = ''                           ;
                            while ( !feof ( $Socket ) )
                            {
                                $Result .= fgets ( $Socket , 4096 ) ;
                            }
                            $Temporary = fclose ( $Socket ) ;
                        }

                        if ( empty ( $Result ) )
                        {
                        }
                        else if ( eregi ( $GLOBALS['Constants']['wget']['Forbidden'] , $Result ) )
                        {
                            $Status = 'Off' ;
                            break ;
                        }
                        else
                        {
                            $Temporary = Set_Licensing_Server ( $Key ) ;
                            $Status = 'On' ;
                            break ;
                        }
                    }
                }
            }
            else if ( eregi ( $GLOBALS['Constants']['wget']['Forbidden'] , $Result ) )
            {
                $Status = 'Off' ;
            }
            else
            {
                $Status = 'On' ;
            }

            // $Temporary = Set_Add_File   ( $Files['License'  ] , $Status  ) ;
            // $Temporary = Set_Permission ( $Files['License'  ] , '777'    ) ;
            // $Temporary = Set_Add_File   ( $Files['Timestamp'] , time ( ) ) ;
            // $Temporary = Set_Permission ( $Files['Timestamp'] , '777'    ) ;

            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'License: Cache Miss' ) ;
                echo Get_Variable_Dump ( $Status               ) ;
            }
            /* Debugging */

        }
        else
        {
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'License: Cache Hit' ) ;
            }
            /* Debugging */
            $Status = $License ;
        }

        return $Status ;

    }
//----------------------------------------------------------------------------//
    function Set_Fantastico_De_Luxe_Status ( $Status )
    {
        $GLOBALS['Public_Settings']['Fantastico_De_Luxe']['Status'] = $Status ;
        $Temporary = Set_Public_Settings ( $GLOBALS['Public_Settings'] ) ;
        return $Temporary ;
    }
//----------------------------------------------------------------------------//
    function Set_Licensing_Server ( $Licensing_Server )
    {
        $GLOBALS['Public_Settings']['Licensing_Server'] = $Licensing_Server ;
        $Temporary = Set_Public_Settings ( $GLOBALS['Public_Settings'] ) ;
        return $Temporary ;
    }
//----------------------------------------------------------------------------//
    function Reset_Licensing_Server ( )
    {
        /* Log */ // echo Get_Variable_Dump ( 'Old Licensing Server: ' . $GLOBALS['Public_Settings']['Licensing_Server'] ) ;
        $Licensing_Server = Get_Random_Licensing_Server ( ) ;
        $Temporary = Set_Licensing_Server ( $Licensing_Server ) ;
        /* Log */ // echo Get_Variable_Dump ( 'New Licensing Server: ' . $GLOBALS['Public_Settings']['Licensing_Server'] ) ;
        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Get_tgz_Prefix ( )
    {
        $tgz_Prefix = '' ;
        if ( 'Stable' == $GLOBALS['Public_Settings']['Fantastico_De_Luxe']['Update_To'] )
        {
            $tgz_Prefix = '' ;
        }
        else if ( 'Latest' == $GLOBALS['Public_Settings']['Fantastico_De_Luxe']['Update_To'] )
        {
            $tgz_Prefix = 'latest_' ;
        }
        else
        {
            $tgz_Prefix = '' ;
        }
        return $tgz_Prefix ;
    }
//----------------------------------------------------------------------------//
    function wget ( $Source , $Destination , $Force = 'No' )
    {
//----------------------------------------------------------------------------//
        $_Command = "rm -f /usr/local/cpanel/whostmgr/docroot/cgi/fantastico/*tgz*" ;
        $_Output = Get_Output ( $_Command ) ;
//----------------------------------------------------------------------------//
        /* Debugging */
        /*
            $Source = 'test.php/' . $Source ;
        */
        /* Debugging */
        /* Debugging */
        /*
            if ( !is_file ( $Destination . $Source ) )
            {
                $Command = 'cp -rfpd "/var/shortcut/' . $Source . '" "' . $Destination . '"' ;
                $Output  = Get_Output ( $Command )                                           ;
                $wget['Command'] = $Command ;
                $wget['Output' ] = 'saved'  ;
            }
            else
            {
                $Command = 'cp -rfpd "/var/shortcut/' . $Source . '" "' . $Destination . '"' ;
                $Output  = Get_Output ( $Command )                                           ;
                $wget['Command'] = $Command ;
                if ( $Force == 'Yes' )
                {
                    $wget['Output' ] = 'saved'  ;
                }
                else
                {
                    $wget['Output' ] = 'no newer'  ;
                }
            }
            return $wget ;
        */
        /* Debugging */
//----------------------------------------------------------------------------//
        if ( 'No' == $Force )
        {
            $Command = $GLOBALS['Private_Settings']['Binaries']['wget'] . ' -N -T ' . $GLOBALS['Private_Settings']['wget']['Time_Out'] . ' -P ' . $Destination . ' "http://' . $GLOBALS['Public_Settings']['Licensing_Server'] . '/files/fantastico/' . $Source . '"' ;
        }
        else
        {
            $Command = $GLOBALS['Private_Settings']['Binaries']['wget'] . ' -T ' . $GLOBALS['Private_Settings']['wget']['Time_Out'] . ' -P ' . $Destination . ' "http://' . $GLOBALS['Public_Settings']['Licensing_Server'] . '/files/fantastico/' . $Source . '"' ;
        }
        $Output  = Get_Output ( $Command , 'On' ) ;

        if ( eregi ( $GLOBALS['Constants']['wget']['Forbidden'] , $Output ) )
        {
        }
        else if ( eregi ( $GLOBALS['Constants']['wget']['Saved'] , $Output ) OR eregi ( $GLOBALS['Constants']['wget']['No_Newer'] , $Output ) )
        {
        }
        else
        {
            foreach ( $GLOBALS['Constants']['Licensing_Servers'] as $Key => $Value )
            {
                if ( $Key != $GLOBALS['Public_Settings']['Licensing_Server'] )
                {
                    if ( 'No' == $Force )
                    {
                        $Command = $GLOBALS['Private_Settings']['Binaries']['wget'] . ' -N -T ' . $GLOBALS['Private_Settings']['wget']['Time_Out'] . ' -P ' . $Destination . ' "http://' . $Key . '/files/fantastico/' . $Source . '"' ;
                    }
                    else
                    {
                        $Command = $GLOBALS['Private_Settings']['Binaries']['wget'] . ' -T ' . $GLOBALS['Private_Settings']['wget']['Time_Out'] . ' -P ' . $Destination . ' "http://' . $Key . '/files/fantastico/' . $Source . '"' ;
                    }
                    $Output  = Get_Output ( $Command , 'On' ) ;

                    if ( eregi ( $GLOBALS['Constants']['wget']['Forbidden'] , $Output ) )
                    {
                        break ;
                    }
                    else if ( eregi ( $GLOBALS['Constants']['wget']['Saved'] , $Output ) || eregi ( $GLOBALS['Constants']['wget']['No_Newer'] , $Output ) )
                    {
                        $Temporary = Set_Licensing_Server ( $Key ) ;
                        break ;
                    }
                    else
                    {
                    }
                }
            }
        }
        $wget['Command'] = $Command ;
        $wget['Output' ] = $Output  ;
        /* Debugging */
        /*
            echo Get_Variable_Dump ( $wget ) ;
        */
        /* Debugging */
        return $wget ;
    }
//----------------------------------------------------------------------------//
    function Decompress ( $Source , $Destination )
    {
        $Command = 'tar -xzpf "' . $Source . '" -C "' . $Destination . '"' ;
        $Output  = Get_Output ( $Command , 'On' ) ;
        if ( eregi ( 'gzip: compressed data not read from a terminal' , $Output ) )
        {
            $Command = 'gunzip -c "' . $Source . '" > "' . $Destination . 'Temporary.tar"' ;
            $Output  = Get_Output ( $Command , 'On' ) ;
            $Command = 'tar -xpf "' . $Destination . 'Temporary.tar" -C "' . $Destination . '"' ;
            $Output  = Get_Output ( $Command , 'On' ) ;
            $Temporary = unlink ( $Destination . 'Temporary.tar' ) ;
        }
        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Get_Scripts ( $Type = '' )
    {

        $Status = 'Off' ;

        if ( 'Deprecated' == $Type )
        {
            $Files['Scripts'  ] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.scripts/.deprecated/.contents'  ;
            $Files['Timestamp'] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.scripts/.deprecated/.timestamp' ;
        }
        else
        {
            $Files['Scripts'  ] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.scripts/.contents'  ;
            $Files['Timestamp'] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.scripts/.timestamp' ;
        }

        if ( is_file ( $Files['Scripts'] ) )
        {
            $Scripts = unserialize ( trim ( file_get_contents ( $Files['Scripts'] ) ) ) ;
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'Scripts: Cached Contents:' ) ;
                echo Get_Variable_Dump ( $Scripts                    ) ;
            }
            /* Debugging */
        }
        else
        {
            $Scripts = '' ;
        }

        if ( is_file ( $Files['Timestamp'] ) )
        {
            $Timestamp = trim ( file_get_contents ( $Files['Timestamp'] ) ) ;
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'Scripts: Cached Timestamp:' ) ;
                echo Get_Variable_Dump ( $Timestamp                   ) ;
            }
            /* Debugging */
        }
        else
        {
            $Timestamp = 0 ;
        }

        if ( !empty ( $Scripts ) AND !empty ( $Timestamp ) )
        {
            if ( $Timestamp >= ( time ( ) - $GLOBALS['Cache']['Period'] ) )
            {
                $Status = 'On' ;
            }
        }

        $Status = 'Off' ;

        if ( 'Off' == $Status )
        {

            $Scripts = Array ( ) ;
            $Contents = '' ;
            if ( $Type == 'Deprecated' )
            {
                //$Contents = Get_File_Contents ( 'fantasticoremotefiles/deprecated.xml' ) ;
                $Contents = file_get_contents ( '/usr/local/cpanel/whostmgr/docroot/cgi/fantastico/includes/deprecated.xml' ) ;
            }
            else
            {
                //$Contents = Get_File_Contents ( 'fantasticoremotefiles/scripts.xml' ) ;
                $Contents = file_get_contents ( '/usr/local/cpanel/whostmgr/docroot/cgi/fantastico/includes/scripts.xml' ) ;
            }
            $Parser = xml_parser_create ( ) ;
            xml_parser_set_option ( $Parser , XML_OPTION_CASE_FOLDING , 0 ) ;
            xml_parser_set_option ( $Parser , XML_OPTION_SKIP_WHITE   , 1 ) ;
            xml_parse_into_struct ( $Parser , $Contents , $Values , $Tags ) ;
            xml_parser_free ( $Parser ) ;
            $Index = 1 ;
            foreach ( $Values As $Key => $Value )
            {
                if ( 'Name' == $Value['tag'] && 'complete' == $Value['type'] )
                {
                    $Scripts[$Index] = $Value['value'] ;
                    $Index++ ;
                }
            }
            $Temporary = natcasesort ( $Scripts ) ;

            // $Temporary = Set_Add_File   ( $Files['Scripts'  ] , serialize ( $Scripts ) ) ;
            // $Temporary = Set_Permission ( $Files['Scripts'  ] , '777'                  ) ;
            // $Temporary = Set_Add_File   ( $Files['Timestamp'] , time ( )               ) ;
            // $Temporary = Set_Permission ( $Files['Timestamp'] , '777'                  ) ;

            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'Scripts: Cache Miss' ) ;
                echo Get_Variable_Dump ( $Scripts              ) ;
            }
            /* Debugging */

        }
        else
        {
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'Scripts: Cache Hit' ) ;
            }
            /* Debugging */
        }

        return $Scripts ;

    }
//----------------------------------------------------------------------------//
    function Get_Missing_Scripts ( )
    {
        $Missing_Scripts = Array ( ) ;
        foreach ( $GLOBALS['Scripts'] as $Script )
        {
            if ( ( !is_file ( $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' . Get_tgz_Prefix ( ) . $Script . '.tgz' ) OR !is_file ( $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' . Get_tgz_Prefix ( ) . $Script . '.ini' ) ) AND !in_array ( $Script , $GLOBALS['Deprecated_Scripts'] ) )
            {
                $Missing_Scripts[] = $Script ;
            }
        }
        return $Missing_Scripts ;
    }
//------------------------------------------------------------------------------//
    function Get_Version_Numbers ( )
    {

        $Status = 'Off' ;

        $Files['Version_Numbers'] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.version_numbers/.contents'  ;
        $Files['Timestamp'      ] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.version_numbers/.timestamp' ;

        if ( is_file ( $Files['Version_Numbers'] ) )
        {
            $Version_Numbers = unserialize ( trim ( file_get_contents ( $Files['Version_Numbers'] ) ) ) ;
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'Version Numbers: Cached Contents:' ) ;
                echo Get_Variable_Dump ( $Version_Numbers                    ) ;
            }
            /* Debugging */
        }
        else
        {
            $Version_Numbers = '' ;
        }

        if ( is_file ( $Files['Timestamp'] ) )
        {
            $Timestamp = trim ( file_get_contents ( $Files['Timestamp'] ) ) ;
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'Version Numbers: Cached Timestamp:' ) ;
                echo Get_Variable_Dump ( $Timestamp                           ) ;
            }
            /* Debugging */
        }
        else
        {
            $Timestamp = 0 ;
        }

        if ( !empty ( $Version_Numbers ) AND !empty ( $Timestamp ) )
        {
            if ( $Timestamp >= ( time ( ) - $GLOBALS['Cache']['Period'] ) )
            {
                $Status = 'On' ;
            }
        }

        $Status = 'Off' ;

        if ( 'Off' == $Status )
        {

            $Version_Numbers = Array ( ) ;
            $Contents = '' ;
            $Contents = Get_File_Contents ( 'fantasticoremotefiles/versionswhm.xml' ) ;
            $Parser = xml_parser_create ( ) ;
            xml_parser_set_option ( $Parser , XML_OPTION_CASE_FOLDING , 0 ) ;
            xml_parser_set_option ( $Parser , XML_OPTION_SKIP_WHITE   , 1 ) ;
            xml_parse_into_struct ( $Parser , $Contents , $Values , $Tags ) ;
            xml_parser_free ( $Parser ) ;
            foreach ( $Values As $Key => $Value )
            {
                if ( 'Version' == $Value['tag'] && 'complete' == $Value['type'] )
                {
                    if ( !empty ( $Value['attributes']['Type'] ) )
                    {
                        $Type = trim ( $Value['attributes']['Type'] ) ;
                    }
                    $Version_Numbers[$Type] = $Value['value'] ;
                }
            }

            // $Temporary = Set_Add_File   ( $Files['Version_Numbers'] , serialize ( $Version_Numbers ) ) ;
            // $Temporary = Set_Permission ( $Files['Version_Numbers'] , '777'                          ) ;
            // $Temporary = Set_Add_File   ( $Files['Timestamp']       , time ( )                       ) ;
            // $Temporary = Set_Permission ( $Files['Timestamp']       , '777'                          ) ;

            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'Version Numbers: Cache Miss' ) ;
                echo Get_Variable_Dump ( $Version_Numbers              ) ;
            }
            /* Debugging */

        }
        else
        {
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'Version Numbers: Cache Hit' ) ;
            }
            /* Debugging */
        }

        return $Version_Numbers ;

    }
//----------------------------------------------------------------------------//
    function Get_Sanitized_String ( $Variable )
    {
        $Variable = trim ( $Variable ) ;
        /*
        if ( get_magic_quotes_gpc ( ) )
        {
            $Variable = stripslashes ( $Variable ) ;
        }
        */
        $Variable = htmlspecialchars ( $Variable , ENT_QUOTES ) ;
        return $Variable ;
    }
//----------------------------------------------------------------------------//
    function Get_File_Contents ( $File )
    {
        $Contents = '' ;
        $Contents = @file_get_contents ( 'http://' . $GLOBALS['Public_Settings']['Licensing_Server'] . '/' . $File ) ;
        if ( empty ( $Contents ) )
        {
            foreach ( $GLOBALS['Constants']['Licensing_Servers'] as $Key => $Value )
            {
                if ( $Key != $GLOBALS['Public_Settings']['Licensing_Server'] )
                {
                    $Contents = @file_get_contents ( 'http://' . $Key . '/' . $File ) ;
                    if ( !empty ( $Contents ) )
                    {
                        $Temporary = Set_Licensing_Server ( $Key ) ;
                        break ;
                    }
                }
            }
        }
        return trim ( $Contents ) ;
    }
//----------------------------------------------------------------------------//
    function Get_IP_Address ( )
    {
        $IP_Address = Get_File_Contents ( 'files/my_real_server_ip.php' ) ;

        $Status = 'Off' ;

        $Files['IP_Address'] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.ip_address/.contents'  ;
        $Files['Timestamp' ] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.ip_address/.timestamp' ;

        if ( is_file ( $Files['IP_Address'] ) )
        {
            $IP_Address = trim ( file_get_contents ( $Files['IP_Address'] ) ) ;
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'IP Address: Cached Contents:' ) ;
                echo Get_Variable_Dump ( $IP_Address                    ) ;
            }
            /* Debugging */
        }
        else
        {
            $IP_Address = '' ;
        }

        if ( is_file ( $Files['Timestamp'] ) )
        {
            $Timestamp = trim ( file_get_contents ( $Files['Timestamp'] ) ) ;
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'IP Address: Cached Timestamp:' ) ;
                echo Get_Variable_Dump ( $Timestamp                      ) ;
            }
            /* Debugging */
        }
        else
        {
            $Timestamp = 0 ;
        }

        if ( !empty ( $IP_Address ) AND !empty ( $Timestamp ) )
        {
            if ( $Timestamp >= ( time ( ) - $GLOBALS['Cache']['Period'] ) )
            {
                $Status = 'On' ;
            }
        }

        $Status = 'Off' ;

        if ( 'Off' == $Status )
        {
            $IP_Address = Get_File_Contents ( 'files/my_real_server_ip.php' ) ;
            // $Temporary = Set_Add_File   ( $Files['IP_Address'] , $IP_Address ) ;
            // $Temporary = Set_Permission ( $Files['IP_Address'] , '777'       ) ;
            // $Temporary = Set_Add_File   ( $Files['Timestamp' ] , time ( )    ) ;
            // $Temporary = Set_Permission ( $Files['Timestamp' ] , '777'       ) ;
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'IP Address: Cache Miss' ) ;
                echo Get_Variable_Dump ( $IP_Address              ) ;
            }
            /* Debugging */
        }
        else
        {
            /* Debugging */
            if ( TRUE == $_SESSION['Debug'] )
            {
                echo Get_Variable_Dump ( 'IP Address: Cache Hit' ) ;
            }
            /* Debugging */
        }

        return $IP_Address ;

    }
//----------------------------------------------------------------------------//
    function Get_Error ( $Command , $Output )
    {
        $Contents = '' ;
        if ( !empty ( $Output ) )
        {
            $Contents .= '<p class="Failure">' ;
            $Contents .= $Command              ;
            $Contents .= '<br/>'               ;
            $Contents .= $Output               ;
            $Contents .= '</p>'                ;
        }
        return $Contents ;
    }
//----------------------------------------------------------------------------//
    function Get_Message ( $Message , $Arguments = Array ( ) )
    {
        $Message = ( empty ( $GLOBALS['Messages'][$Message] ) ) ? $Message : $GLOBALS['Messages'][$Message] ;
        return call_user_func_array ( 'sprintf' , array_merge ( ( Array ) $Message , $Arguments ) ) ;
    }
//----------------------------------------------------------------------------//
    function Get_Files ( $Directory )
    {
        $Files = Array ( ) ;
        if ( is_dir ( $Directory ) )
        {
            if ( $Handle = opendir ( $Directory ) )
            {
                while ( false !== ( $File = readdir ( $Handle ) ) )
                {
                    if ( '.' != $File AND '..' != $File )
                    {
                        $Files[] = $File ;
                    }
                }
                $Temporary = closedir ( $Handle ) ;
            }
        }
        return $Files ;
    }
//----------------------------------------------------------------------------//
    function Get_Output ( $Command , $Debug = 'On' )
    {
        ob_flush ( ) ;
        flush ( ) ;
        $Output = '' ;
        $Output = `$Command 2>&1` ;
        ob_flush ( ) ;
        flush ( ) ;
        if ( ( 'On' == $Debug AND 'On' == $GLOBALS['Private_Settings']['Debug']['Status'] ) OR ( 0 ) )
        {
            echo Get_Variable_Dump ( $Command . "\n" . $Output ) ;
        }
        ob_flush ( ) ;
        flush ( ) ;
        return $Output ;
    }
//----------------------------------------------------------------------------//
    function Check_And_Repair_Folders_And_Files ( )
    {
        $Directories   = Array ( ) ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/'                                                      ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/archives/'                                             ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/'                          ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/'                                   ;
        // $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/'                             ;
        // $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.license/'                    ;
        // $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.version_numbers/'            ;
        // $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.ip_address/'                 ;
        // $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.news/'                       ;
        // $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.scripts/'                    ;
        // $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/cache/.scripts/.deprecated/'        ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/master_files/'                      ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/'                       ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/disabled/'              ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/disabled/hosting_plans/';
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/disabled/resellers/'    ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/disabled/users/'        ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/enabled/'               ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/enabled/hosting_plans/' ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/enabled/resellers/'     ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/enabled/users/'         ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/features_sets/'                                        ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/features_sets/resellers/'                              ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/features_sets/hosting_plans/'                          ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/features_sets/sets/'                                   ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/features_sets/sets/default/'                           ;
        $Directories[] = $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/features_sets/users/'                                  ;
        foreach ( $Directories As $Key => $Directory )
        {
            if ( !is_dir ( $Directory ) )
            {
                $Temporary = mkdir ( $Directory ) ;
                $Temporary = chmod ( $Directory , 0755 ) ;
            }
        }
        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Get_Variable_Dump ( $Anything )
    {
        $Output = '<pre>' ;
        if ( is_array ( $Anything ) OR is_object ( $Anything ) )
        {
            $Temporary = ob_start ( ) ;
            $Temporary = print_r ( $Anything ) ;
            $Output .= ob_get_contents ( ) ;
            ob_end_clean ( ) ;
        }
        else
        {
            $Output .= $Anything ;
        }
        $Output .= '</pre>' ;
        return $Output ;
    }
    /*
    function Get_Variable_Dump ( $Anything )
    {
        $Output    = '' ;
        $Temporary = ob_start ( ) ;
        $Output   .= '<pre class="Debugging">' ;
        if ( is_array ( $Anything ) OR is_object ( $Array ) )
        {
            $Output .= var_export ( $Anything , TRUE ) ;
        }
        else
        {
            $Output .= $Anything ;
        }
        $Output   .= '</pre>' ;
        return $Output ;
    }
    */
//----------------------------------------------------------------------------//
    function Get_Select_Options ( $Options , $Default_Value , $Indexes = 'Disabled' )
    {
        $Output = Array ( ) ;
        if ( empty ( $Default_Value ) )
        {
            $Default_Value = '' ;
        }
        foreach ( $Options As $Key => $Value )
        {
            if ( $Indexes == 'Disabled' )
            {
                $Key = $Value ;
            }
            $Selected = '' ;
            if ( $Key == $Default_Value )
            {
                $Selected = ' selected="selected"' ;
            }
            $Output[] = '<option value="' . $Key . '"' . $Selected . '>' . $Value . '</option>' ;
        }
        $Output = implode ( '' , $Output ) ;
        return $Output ;
    }
//----------------------------------------------------------------------------//
    function Get_Public_Settings_Paths_cPanel_Fantastico_De_Luxe ( $Temporary )
    {
        $Directories = Get_Files ( $Temporary ) ;
        foreach ( $Directories As $Directory )
        {
            if ( is_dir ( $Temporary . $Directory . '/fantastico/' ) )
            {
                $Temporary = realpath ( $Temporary . $Directory . '/fantastico/' ) ;
                if ( substr ( $Temporary , -1 ) != '/' )
                {
                    $Temporary = $Temporary . '/' ;
                }
                break ;
            }
        }
        /* Debugging */ // echo Get_Variable_Dump ( $Temporary ) ;
        return $Temporary ;
    }
//----------------------------------------------------------------------------//
    function Get_Crons ( )
    {
        $Cron = Array ( ) ;
        $Command = 'crontab -l'    ;
        $Output  = Get_Output ( $Command , 'Off' ) ;
        $Output  = explode ( "\n" , $Output ) ;
        foreach ( $Output As $Line )
        {
            $Line = trim ( $Line ) ;
            if ( !empty ( $Line ) )
            {
                $Cron[] = $Line ;
            }
        }
        return $Cron ;
    }
//----------------------------------------------------------------------------//
    function Set_Cron ( $Cron )
    {
        $Cron      = trim ( implode ( "\n" , $Cron ) ) ;
        $File      = tempnam ( '' , '' ) ;
        $Handle    = fopen ( $File , 'w' ) ;
        $Temporary = fwrite ( $Handle , $Cron . "\n" ) ;
        $Temporary = fclose ( $Handle ) ;
        $Command   = 'crontab ' . $File ;
        $Output    = Get_Output ( $Command , 'Off' ) ;
        $Temporary = unlink ( $File ) ;
        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Delete_Cron ( $Line )
    {
        $Temporary = Get_Crons ( ) ;
        $Cron = Array ( ) ;
        foreach ( $Temporary As $Key => $Value )
        {
            if ( stristr ( $Value , $Line ) == FALSE )
            {
                $Cron[] = $Value ;
            }
        }
        $Temporary = Set_Cron ( $Cron ) ;
        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Add_Cron ( $Line )
    {
        $Cron      = Get_Crons (       ) ;
        $Cron[]    = $Line              ;
        $Temporary = Set_Cron ( $Cron ) ;
        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Get_Resellers ( )
    {
        $Resellers = Array ( ) ;
        if ( is_file ( $GLOBALS['Constants']['Paths']['cPanel']['Resellers'] ) )
        {
            $Temporary = file ( $GLOBALS['Constants']['Paths']['cPanel']['Resellers'] ) ;
            foreach ( $Temporary As $Line )
            {
                $Position = 0 ;
                $Position = strpos ( $Line , ':' ) ;
                $Line = substr ( $Line , 0 , $Position ) ;
                $Resellers[] = $Line ;
            }
        }
        $Resellers[] = 'root' ;
        $Resellers = array_unique ( $Resellers ) ;
        natcasesort ( $Resellers ) ;
        return $Resellers ;
    }
//----------------------------------------------------------------------------//
    function Set_Add_File ( $File , $Contents )
    {

        $Handle = fopen ( $File , 'w' ) ;
        if ( TRUE == $Handle )
        {
            $Temporary = fwrite ( $Handle , $Contents ) ;
            $Temporary = fclose ( $Handle             ) ;
        }

        return TRUE ;

    }
//----------------------------------------------------------------------------//
    function Set_Permission ( $File , $Permission )
    {
        $Command = 'chmod ' . $Permission . ' "' . $File . '"' ;
        $Output  = Get_Output ( $Command ) ;
        return TRUE ;
    }
//----------------------------------------------------------------------------//
    function Get_Latest_Version ( $Script )
    {
        $Temporary = parse_ini_file ( $GLOBALS['Public_Settings']['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' . Get_tgz_Prefix ( ) . $Script . '.ini' , TRUE ) ;
        return $Temporary['Others']['Version_Number'] ? $Temporary['Others']['Version_Number'] : '' ;
    }
//----------------------------------------------------------------------------//
    function rpm_qa_wget ( )
    {

        $Command = 'rpm -qa wget' ;

        $Output = Get_Output ( $Command ) ;
        $Output = trim ( $Output ) ;

        $Array = Array ( ) ;

        $Array[] = 'wget-1.10.2-3.3.fc5' ;
        $Array[] = 'wget-1.10.2-8.fc6.1' ;

        if ( in_array ( $Output , $Array ) == TRUE )
        {
            $Status = $Output ;
        }
        else
        {

            $Status = NULL ;

            /*

            $_Command = "find /usr/local/cpanel/whostmgr/docroot/cgi/fantastico/ -iname '*tgz*'" ;

            $_Output = Get_Output ( $_Command ) ;
            $_Output = trim ( $_Output ) ;

            if ( empty ( $_Output ) )
            {
                $Status = NULL ;
            }
            else
            {
                $Status = $Output ;
            }

            */

        }

        return $Status ;

    }
//----------------------------------------------------------------------------//
?>
