<?php
//----------------------------------------------------------------------------//
    /* Debugging */ // echo Get_Variable_Dump ( $_REQUEST ) ;
//----------------------------------------------------------------------------//
    $List     = '' ;
    $Order_By = '' ;
//----------------------------------------------------------------------------//
    if ( !empty ( $_REQUEST['List'] ) )
    {
        $List = $_REQUEST['List'] ;
        $Order_By = 'Users' ;
    }
    else if ( !empty ( $_REQUEST['Order_By'] ) )
    {
        $List     = 'All' ;
        $Order_By = $_REQUEST['Order_By'] ;
    }
    else
    {
        // $List     = 'All' ;
        // $Order_By = 'Users' ;
    }
//----------------------------------------------------------------------------//
    $Users = Get_Files ( $Constants['Paths']['cPanel']['Users'] ) ;
    foreach ( $Users As $Key => $Value )
    {
        $Domain_Name    = '' ;
        $Home_Directory = '' ;
        $Domain_Name = Get_Domain_Name ( $Value ) ;
        if ( !empty ( $Domain_Name ) )
        {
            $Home_Directory = Get_Home_Directory ( $Domain_Name ) ;
        }
        if (  '.' == $Value OR '..' == $Value OR empty ( $Domain_Name ) OR empty ( $Home_Directory ) )
        {
            unset ( $Users[$Key] ) ;
        }
    }
    natcasesort ( $Users ) ;
//----------------------------------------------------------------------------//
?>

    <div class="Block">

        <h1><?php echo Get_Message ( 'Installations Overview' ) ; ?></h1>

        <form id="" name="" action="?">

        <p>
            <strong><?php echo Get_Message ( 'List all installations of ' ) ; ?></strong>
            <select name="Script">
<?php
//----------------------------------------------------------------------------//
    foreach ( $Scripts as $Script )
    {
//----------------------------------------------------------------------------//
        $Selected = '' ;
        if ( !empty ( $_REQUEST['Script'] ) && $_REQUEST['Script'] == $Script )
        {
            $Selected = ' selected="selected"' ;
        }
//----------------------------------------------------------------------------//
?>
                <option value="<?php echo $Script ; ?>"<?php echo $Selected ; ?>><?php echo get_new_name ( $Script ) ; ?></option>
<?php
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
?>
            </select>
            <input type="submit" name="Submit" value="<?php echo Get_Message ( 'Go' ) ; ?>">
        </p>

        <input type="hidden" name="Primary_Action" value="Installations_Overview">
        <input type="hidden" name="List" value="Scripts">
        <input type="hidden" name="Order_By" value="Users">

        </form>

        <form id="" name="" action="?">

        <p>
            <strong><?php echo Get_Message ( 'List all installations of ' ) ; ?> </strong>
            <select name="User">
<?php
//----------------------------------------------------------------------------//
    foreach ( $Users as $User )
    {
//----------------------------------------------------------------------------//
        $Selected = '' ;
        if ( !empty ( $_REQUEST['User'] ) && $_REQUEST['User'] == $User )
        {
            $Selected = ' selected="selected"' ;
        }
//----------------------------------------------------------------------------//
?>
                <option value="<?php echo $User ; ?>"<?php echo $Selected ; ?>><?php echo $User ; ?></option>
<?php
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
?>
            </select>
            <input type="submit" name="Submit" value="<?php echo Get_Message ( 'Go' ) ; ?>">
        </p>

        <input type="hidden" name="Primary_Action" value="Installations_Overview">
        <input type="hidden" name="List" value="Users">
        <input type="hidden" name="Order_By" value="Scripts">

        </form>

    </div>

<?php
//----------------------------------------------------------------------------//
    $Scripts_Link   = '<a href="' . $Constants['URLs']['WHM']['Fantastico_De_Luxe'] . 'fantastico.php?Primary_Action=Installations_Overview&amp;Order_By=Scripts">' . Get_Message ( 'Scripts' ) . '</a>' ;
    $Users_Link = '<a href="' . $Constants['URLs']['WHM']['Fantastico_De_Luxe'] . 'fantastico.php?Primary_Action=Installations_Overview&amp;Order_By=Users">' . Get_Message ( 'Users' ) . '</a>'  ;
//----------------------------------------------------------------------------//
    if ( $List == 'All' )
    {
        switch ( $Order_By )
        {
            case 'Scripts' :
                $Scripts_Link   = Get_Message ( 'Scripts' ) ;
                break ;
            case 'Users' :
                $Users_Link = Get_Message ( 'Users' ) ;
                break ;
        }
    }
//----------------------------------------------------------------------------//
?>

    <div class="Block">
        <p>
            <span class="Success"><strong><?php echo Get_Message ( 'List all installations sorted by [%s] - [%s]' , Array ( $Users_Link , $Scripts_Link ) ) ; ?></strong></span>
        </p>
    </div>

<?php
//----------------------------------------------------------------------------//
if ( ! empty ( $List ) AND ! empty ( $Order_By ) )
{
//----------------------------------------------------------------------------//
    $Installation_Overviews = Array ( ) ;
//----------------------------------------------------------------------------//
    foreach ( $Users as $Index => $User )
    {
//----------------------------------------------------------------------------//
        $Domain_Name    = '' ;
        $Home_Directory = '' ;
//----------------------------------------------------------------------------//
        $Domain_Name    = Get_Domain_Name    ( $User        ) ;
        if ( !empty ( $Domain_Name ) )
        {
            $Home_Directory = Get_Home_Directory ( $Domain_Name ) ;
        }
        /* Debugging */ // echo Get_Variable_Dump ( $User . '-' . $Domain_Name . '-' . $Home_Directory ) ;
//----------------------------------------------------------------------------//
        if ( empty ( $Domain_Name ) || empty ( $Home_Directory ) )
        {
            $Installation_Overviews[$User] = 'Error - Home Directory' ;
        }
        else
        {
//----------------------------------------------------------------------------//
            foreach ( $Scripts as $Script )
            {
//----------------------------------------------------------------------------//
                $Registry_Directory = $Home_Directory . '/.fantasticodata/' . $Script ;
                // echo Get_Variable_Dump ( $Registry_Directory ) ; flush ( ) ;
                $Registry_Files     = Get_Files ( $Registry_Directory ) ;
                // echo Get_Variable_Dump ( $Registry_Files ) ; flush ( ) ;
                if ( !empty ( $Registry_Files ) AND is_array ( $Registry_Files ) )
                {
                    $Temporary = natcasesort ( $Registry_Files ) ;
                }
//----------------------------------------------------------------------------//
                if ( !empty ( $Registry_Files ) )
                {
//----------------------------------------------------------------------------//
                    foreach ( $Registry_Files As $Registry_File )
                    {
                        $Installation_Overview = Get_Installation_Overview ( $Registry_Directory , $Registry_File , $Domain_Name , $Home_Directory ) ;
                        $Installation_Overviews[$User][$Script][] = $Installation_Overview ;
                        $Installation_Overviews[$Script][$User][] = $Installation_Overview ;
                    }
//----------------------------------------------------------------------------//
                }
//----------------------------------------------------------------------------//
            }
//----------------------------------------------------------------------------//
        }
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
}
//----------------------------------------------------------------------------//
if ( ! empty ( $List ) AND ! empty ( $Order_By ) )
{
?>

    <div class="Block">

        <table>

<?php
}
//----------------------------------------------------------------------------//
    if ( 'All' == $List AND 'Scripts' == $Order_By )
    {
        Get_Primary_Header_Template ( Get_Message ( 'List of all installations sorted by %s' , Array ( Get_Message ( 'Scripts' ) ) ) ) ;
        foreach ( $Scripts as $Script )
        {
            if ( count ( $Installation_Overviews[$Script] ) )
            {
                Get_Primary_Header_Template ( get_new_name ( $Script ) ) ;
                foreach ( $Users as $User )
                {
                    if ( 'Error - Home Directory' == $Installation_Overviews[$User] )
                    {
                        /*
                            Get_Secondary_Header_Template ( $User ) ;
                            Get_Error_Template ( Get_Message ( 'The home path for this user could not be determined.' ) ) ;
                        */
                    }
                    else
                    {
                        if ( !empty ( $Installation_Overviews[$Script][$User] ) )
                        {
                            Get_Secondary_Header_Template ( $User ) ;
                            $Index = 1 ;
                            foreach ( $Installation_Overviews[$Script][$User] As $Installation_Overview )
                            {
                                Get_Installation_Overview_Template ( $Index , $Installation_Overview['Link'] , $Installation_Overview['Title'] , $Installation_Overview['Version_Number'] , $Installation_Overview['Class'] ) ;
                                $Index = $Index + 1 ;
                            }
                        }
                        else
                        {
                            /*
                                Get_Secondary_Header_Template ( $User ) ;
                                Get_Content_Template ( Get_Message ( 'None' ) ) ;
                            */
                        }
                    }
                }
            }
            else
            {
                /*
                    Get_Primary_Header_Template ( str_replace ( '_' , ' ' , $_Script ) ) ;
                    Get_Content_Template ( Get_Message ( 'None' ) ) ;
                */
            }
        }
    }
    else if ( 'All' == $List AND 'Users' == $Order_By )
    {
        Get_Primary_Header_Template ( Get_Message ( 'List of all installations sorted by %s' , Array ( Get_Message ( 'Users' ) ) ) ) ;
        foreach ( $Users as $User )
        {
            if ( 'Error - Home Directory' == $Installation_Overviews[$User] )
            {
                /*
                    Get_Primary_Header_Template ( $User ) ;
                    Get_Error_Template ( Get_Message ( 'The home path for this user could not be determined.' ) ) ;
                */
            }
            else
            {
                if ( count ( $Installation_Overviews[$User] ) )
                {
                    Get_Primary_Header_Template ( $User ) ;
                    foreach ( $Scripts as $Script )
                    {
                        if ( count ( $Installation_Overviews[$User][$Script] ) )
                        {
                            Get_Secondary_Header_Template ( get_new_name ( $Script ) ) ;
                            $Index = 1 ;
                            foreach ( $Installation_Overviews[$User][$Script] As $Installation_Overview )
                            {
                                Get_Installation_Overview_Template ( $Index , $Installation_Overview['Link'] , $Installation_Overview['Title'] , $Installation_Overview['Version_Number'] , $Installation_Overview['Class'] ) ;
                                $Index = $Index + 1 ;
                            }
                        }
                        else
                        {
                            /*
                                Get_Secondary_Header_Template ( str_replace ( '_' , ' ' , $_Script ) ) ;
                                Get_Content_Template ( Get_Message ( 'None' ) ) ;
                            */
                        }
                    }
                }
                else
                {
                    /*
                    	Get_Primary_Header_Template ( $User ) ;
	                    Get_Content_Template ( Get_Message ( 'None' ) ) ;
	                */
                }
            }
        }
    }
    else if ( 'Scripts' == $List )
    {
        $Temporary = $_REQUEST['Script'] ;
        /* Debugging */ // echo Get_Variable_Dump ( $Installation_Overviews[$Temporary] ) ;
        if ( count ( $Installation_Overviews[$Temporary] ) )
        {
            Get_Primary_Header_Template ( Get_Message ( 'List of all installations of %s' , Array ( get_new_name ( $Temporary ) ) ) ) ;
            foreach ( $Users as $User )
            {
                if ( 'Error - Home Directory' == $Installation_Overviews[$User] )
                {
                    /*
                        Get_Secondary_Header_Template ( $User ) ;
                        Get_Error_Template ( Get_Message ( 'The home path for this user could not be determined.' ) ) ;
                    */
                }
                else
                {
                    if ( !empty ( $Installation_Overviews[$Temporary][$User] ) )
                    {
                        Get_Secondary_Header_Template ( $User ) ;
                        $Index = 1 ;
                        foreach ( $Installation_Overviews[$Temporary][$User] As $Installation_Overview )
                        {
                            Get_Installation_Overview_Template ( $Index , $Installation_Overview['Link'] , $Installation_Overview['Title'] , $Installation_Overview['Version_Number'] , $Installation_Overview['Class'] ) ;
                            $Index = $Index + 1 ;
                        }
                    }
                    else
                    {
                        /*
                            Get_Secondary_Header_Template ( $User ) ;
                            Get_Content_Template ( Get_Message ( 'None' ) ) ;
                        */
                    }
                }
            }
        }
        else
        {
            Get_Primary_Header_Template ( Get_Message ( 'List of all installations of %s' , Array ( str_replace ( '_' , ' ' , $_Temporary ) ) ) ) ;
            Get_Content_Template ( Get_Message ( 'None' ) ) ;
        }
    }
    else if ( 'Users' == $List )
    {
        $Temporary = $_REQUEST['User'] ;
        /* Debugging */ // echo Get_Variable_Dump ( $Installation_Overviews[$Temporary] ) ;
        if ( 'Error - Home Directory' == $Installation_Overviews[$Temporary] )
        {
            /*
                Get_Primary_Header_Template ( Get_Message ( 'List of all installations of %s' , Array ( $Temporary ) ) ) ;
                Get_Error_Template ( Get_Message ( 'The home path for this user could not be determined.' ) ) ;
            */
        }
        else
        {
            if ( count ( $Installation_Overviews[$Temporary] ) )
            {
                Get_Primary_Header_Template ( Get_Message ( 'List of all installations of %s' , Array ( $Temporary ) ) ) ;
                foreach ( $Scripts as $Script )
                {
                    if ( !empty ( $Installation_Overviews[$Temporary][$Script] ) )
                    {
                        Get_Secondary_Header_Template ( get_new_name ( $Script ) ) ;
                        $Index = 1 ;
                        foreach ( $Installation_Overviews[$Temporary][$Script] As $Installation_Overview )
                        {
                            Get_Installation_Overview_Template ( $Index , $Installation_Overview['Link'] , $Installation_Overview['Title'] , $Installation_Overview['Version_Number'] , $Installation_Overview['Class'] ) ;
                            $Index = $Index + 1 ;
                        }
                    }
                    else
                    {
                        /*
                            Get_Secondary_Header_Template ( str_replace ( '_' , ' ' , $_Script ) ) ;
                            Get_Content_Template ( Get_Message ( 'None' ) ) ;
                        */
                    }
                }
            }
            else
            {
                Get_Primary_Header_Template ( Get_Message ( 'List of all installations of %s' , Array ( $Temporary ) ) ) ;
                Get_Content_Template ( Get_Message ( 'None' ) ) ;
            }
        }
    }
//----------------------------------------------------------------------------//
if ( ! empty ( $List ) AND ! empty ( $Order_By ) )
{
?>

        </table>

    </div>

<?php
}
?>

    <div class="Block">
        <p><strong>(unknown)</strong>: <?php echo Get_Message ( 'Fantastico was unable to find the files required to determine the version of this installation.' ) ; ?></p>
        <p><span class="Success"><strong>(X)</strong></span>: <?php echo Get_Message ( 'The directory indicated in the Fantastico registry can not be read due to security restrictions.' ) ; ?></p>
        <p><span class="Failure"><strong>(X)</strong></span>: <?php echo Get_Message ( 'The directory indicated in the Fantastico registry does not exist. This might be a result of manually renaming or moving it but also of manually removing it. In the latter case, the MySQL database and MySQL user might still exist although of no more use.' ) ; ?></p>
    </div>
