<?php
//------------------------------------------------------------------------------//
    if ( ! function_exists ( 'get_new_name' ) )
    {
        function get_new_name ( $old_name )
        {
            $old_name = str_replace ( '_' , ' ' , $old_name ) ;
            switch ( $old_name )
            {
                case 'Mambo Open Source' : $new_name = 'Mambo'                  ; break ;
                case 'TikiWiki'          : $new_name = 'TikiWiki CMS/Groupware' ; break ;
                case 'phpBB2'            : $new_name = 'phpBB'                  ; break ;
                default                  : $new_name = $old_name                ;
            }
            return $new_name ;
        }
    }
//------------------------------------------------------------------------------//
    if ( $Secondary_Action == 'Clean_Up' AND !is_dir ( $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/master_tarballed/' ) )
    {
//------------------------------------------------------------------------------//
        if ( 'Pre' == $Tertiary_Action )
        {
//------------------------------------------------------------------------------//
?>

    <form action="<?php echo $Constants['URLs']['WHM']['Fantastico_De_Luxe'] ; ?>fantastico.php">

        <div class="Block">
            <h1><?php echo Get_Message ( 'Security clean up' ) ; ?></h1>
            <p>
                <strong>
                    <?php echo Get_Message ( 'All master files will be removed. If you have modified any master files, you need to copy the modified files into %snetenberg/fantastico_de_luxe/master_files/{Script}/ retaining the directory structure.' , Array ( $Public_Settings['Paths']['Netenberg'] ) ) ; ?>
                </strong>
            </p>
            <p class="Failure">
                <strong>
                    <?php echo Get_Message ( 'Proceed only if you have a backup of your modifications (if any)' ) ; ?>
                </strong>
            </p>
            <p class="Center">
                <input name="Submit" type="submit" value="<?php echo Get_Message ( 'Delete' ) ; ?>"/>
            </p>

            <input name="Primary_Action"   type="hidden" value="Scripts" />
            <input name="Secondary_Action" type="hidden" value="Clean_Up"/>
            <input name="Tertiary_Action"  type="hidden" value="Post"    />

        </div>

    </form>

<?php
//------------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
        if ( 'Post' == $Tertiary_Action )
        {
//------------------------------------------------------------------------------//
            $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/master_files/*' ;
            $Output  = Get_Output ( $Command ) ;
//------------------------------------------------------------------------------//
?>

    <div class="Block">
        <h1><?php echo Get_Message ( 'Security clean up' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'All master files have been removed.' ) ; ?>
        </p>
    </div>

<?php
//------------------------------------------------------------------------------//
            $Command = 'mkdir ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/master_tarballed/' ;
            $Output  = Get_Output ( $Command ) ;
//------------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
    if ( $Secondary_Action == 'Manage' )
    {
//------------------------------------------------------------------------------//
        if ( $Tertiary_Action == 'Missing' )
        {
//------------------------------------------------------------------------------//
            $Missing_Scripts = Get_Missing_Scripts ( ) ;
//------------------------------------------------------------------------------//
            if ( !empty ( $Missing_Scripts ) )
            {
//------------------------------------------------------------------------------//
                $Contents = Array ( ) ;
                foreach ( $Missing_Scripts as $Script )
                {
                    $Contents[] = '<span class="Success"><strong>' . get_new_name ( $Script ) . '</strong></span>' ;
                }
                $Contents = implode ( '<br/>' , $Contents ) ;
//------------------------------------------------------------------------------//
?>
    <div class="Block">
        <p>
            <span class="Failure">
                <strong>
                    <?php echo Get_Message ( 'Not all available master files and support files are present. %sClick here%s to download the following master files and support files.' , Array ( '<a href="' . $Constants['URLs']['WHM']['Fantastico_De_Luxe'] . 'fantastico.php?Primary_Action=Scripts&Secondary_Action=Update&Tertiary_Action=Missing">' , '</a>' ) ) ; ?>
                </strong>
            </span>
            <br/>
            <?php echo $Contents ; ?>
        </p>
    </div>
<?php
//------------------------------------------------------------------------------//
            }
//------------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
    }
//------------------------------------------------------------------------------//
    if ( $Secondary_Action == 'Update' )
    {
//------------------------------------------------------------------------------//
        $Temporary = Set_Fantastico_De_Luxe_Status ( 'Off' ) ;
//------------------------------------------------------------------------------//
        $Pre_Scripts_Upgrade = '/usr/local/cpanel/whostmgr/docroot/cgi/fantastico/scripts/pre_scripts_upgrade.php' ;
        if ( is_file ( $Pre_Scripts_Upgrade ) )
        {
            include $Pre_Scripts_Upgrade ;
        }
//------------------------------------------------------------------------------//
?>
    <div class="Block">
        <h1 class="Yes_Padding"><?php echo Get_Message ( 'Fantastico De Luxe master files update' ) ; ?></h1>
<?php
//------------------------------------------------------------------------------//
        if ( $Tertiary_Action == 'Missing' )
        {
            $Scripts = Get_Missing_Scripts ( ) ;
        }
//------------------------------------------------------------------------------//
        if ( $Tertiary_Action == 'All' )
        {
        }
//------------------------------------------------------------------------------//
        $At_Least_One = 'No' ;
//----------------------------------------------------------------------------//
        foreach ( $Scripts as $Script )
        {
//------------------------------------------------------------------------------//
            if ( !in_array ( $Script , $Deprecated_Scripts ) )
            {
//------------------------------------------------------------------------------//
                if ( !empty ( $Force ) )
                {
                    $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' . Get_tgz_Prefix ( ) . $Script . '.tgz' ;
                    $Output  = Get_Output ( $Command , 'On' ) ;
                    $wget = wget ( Get_tgz_Prefix ( ) . $Script . '.tgz' , $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' , 'Yes' ) ;
                }
                else
                {
                    $wget = wget ( Get_tgz_Prefix ( ) . $Script . '.tgz' , $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' ) ;
                }
//------------------------------------------------------------------------------//
                if ( eregi ( $Constants['wget']['Saved'] , $wget['Output'] ) )
                {
//------------------------------------------------------------------------------//
                    $At_Least_One = 'Yes' ;
//------------------------------------------------------------------------------//
?>
        <p class="No_Padding">
            <?php echo Get_Message ( '%s has been fetched.' , Array ( '<span class="Success"><strong>' . get_new_name ( $Script ) . '</strong></span>' ) ) ; ?>
        </p>
<?php
//------------------------------------------------------------------------------//
                }
                else if ( eregi ( $Constants['wget']['No_Newer'] , $wget['Output'] ) )
                {
//------------------------------------------------------------------------------//
//------------------------------------------------------------------------------//
                }
                else if ( eregi ( $Constants['wget']['Service_Unavailable'] , $wget['Output'] ) )
                {
//------------------------------------------------------------------------------//
?>
        <h1 class="Failure<?php echo ( !empty ( $At_Least_One ) AND 'Yes' == $At_Least_One ) ? '' : ' No_Padding' ; ?>"><?php echo Get_Message ( 'Update is currently not possible. Please retry later.' ) ; ?></h1>
<?php
                    $At_Least_One = 'Yes' ;
                    break ;
//------------------------------------------------------------------------------//
                }
                else if ( eregi ( $Constants['wget']['Forbidden'] , $wget['Output'] ) )
                {
                    $At_Least_One = 'Yes' ;
//------------------------------------------------------------------------------//
?>
	    <h1 class="Failure No_Padding"><?php echo Get_Message ( 'This server is not properly licensed.' ) ; ?></h1>
	    <p>
	        <?php echo Get_Message ( 'Your main server IP as currently seen by our servers is %s.%sIf you have submitted a different IP for licensing, please contact your NOC if this is a NOC license or email %s with order number, currently licensed IP and new IP (%s) if this is a self-purchased license.%sIf this is a self-purchased license, it may also have expired. In this case, please follow the payment link in the renewal notification which you have received by email in order to renew your license.%sIf you ran a demo version of Fantastico, you now need to %spurchase a full license.%s' , Array ( '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<a href="mailto:sales@netenberg.com">sales@netenberg.com</a>' , '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<br/>' , '<a href="http://netenberg.com/shop/" target="_blank">' , '</a>' ) ) ; ?>
	    </p>
<?php
//------------------------------------------------------------------------------//
                    break ;
                }
                else
                {
                    $At_Least_One = 'Yes' ;
?>
        <h1 class="No_Padding"><?php echo Get_Message ( 'wget Error' ) ; ?></h1>
<?php
                    echo Get_Error ( $wget['Command'] , $wget['Output'] ) ;
                    break ;
                }
//------------------------------------------------------------------------------//
                if ( !empty ( $Force ) )
                {
                    $Command = 'rm -rf ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' . Get_tgz_Prefix ( ) . $Script . '.ini' ;
                    $Output  = Get_Output ( $Command , 'On' ) ;
                    $wget = wget ( Get_tgz_Prefix ( ) . $Script . '.ini' , $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' , 'Yes' ) ;
                }
                else
                {
                    $wget = wget ( Get_tgz_Prefix ( ) . $Script . '.ini' , $Public_Settings['Paths']['Netenberg'] . 'netenberg/archives/fantastico_de_luxe/' ) ;
                }
//------------------------------------------------------------------------------//
                if ( eregi ( $Constants['wget']['Saved'] , $wget['Output'] ) )
                {
//------------------------------------------------------------------------------//
                    $At_Least_One = 'Yes' ;
//------------------------------------------------------------------------------//
?>
        <p class="No_Padding">
            <?php echo Get_Message ( '%s support file has been fetched.' , Array ( '<span class="Success"><strong>' . get_new_name ( $Script ) . '</strong></span>' ) ) ; ?>
        </p>
<?php
//------------------------------------------------------------------------------//
                }
                else if ( eregi ( $Constants['wget']['No_Newer'] , $wget['Output'] ) )
                {
//------------------------------------------------------------------------------//
//------------------------------------------------------------------------------//
                }
                else if ( eregi ( $Constants['wget']['Service_Unavailable'] , $wget['Output'] ) )
                {
//------------------------------------------------------------------------------//
?>
        <h1 class="Failure<?php echo ( !empty ( $At_Least_One ) AND 'Yes' == $At_Least_One ) ? '' : ' No_Padding' ; ?>"><?php echo Get_Message ( 'Update is currently not possible. Please retry later.' ) ; ?></h1>
<?php
                    $At_Least_One = 'Yes' ;
                    break ;
//------------------------------------------------------------------------------//
                }
                else if ( eregi ( $Constants['wget']['Forbidden'] , $wget['Output'] ) )
                {
                    $At_Least_One = 'Yes' ;
//------------------------------------------------------------------------------//
?>
        <h1 class="Failure No_Padding"><?php echo Get_Message ( 'This server is not properly licensed.' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Your main server IP as currently seen by our servers is %s.%sIf you have submitted a different IP for licensing, please contact your NOC if this is a NOC license or email %s with order number, currently licensed IP and new IP (%s) if this is a self-purchased license.%sIf this is a self-purchased license, it may also have expired. In this case, please follow the payment link in the renewal notification which you have received by email in order to renew your license.%sIf you ran a demo version of Fantastico, you now need to %spurchase a full license.%s' , Array ( '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<a href="mailto:sales@netenberg.com">sales@netenberg.com</a>' , '<strong>' . $IP_Address . '</strong>' , '<br/>' , '<br/>' , '<a href="http://netenberg.com/shop/" target="_blank">' , '</a>' ) ) ; ?>
        </p>
<?php
//------------------------------------------------------------------------------//
                    break ;
                }
                else
                {
                    $At_Least_One = 'Yes' ;
?>
        <h1 class="No_Padding"><?php echo Get_Message ( 'wget Error' ) ; ?></h1>
<?php
                    echo Get_Error ( $wget['Command'] , $wget['Output'] ) ;
                    break ;
                }
//------------------------------------------------------------------------------//
            }
//------------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
        if ( 'No' == $At_Least_One )
        {
//------------------------------------------------------------------------------//
?>
        <p class="No_Padding">
            <?php echo Get_Message ( '%sNo newer%s master files available.' , Array ( '<strong>' , '</strong>' ) ) ; ?>
        </p>
<?php
//------------------------------------------------------------------------------//
        }
        else
        {
//----------------------------------------------------------------------------//
//----------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
?>
    </div>
<?php
//----------------------------------------------------------------------------//
        $Post_Scripts_Upgrade = '/usr/local/cpanel/whostmgr/docroot/cgi/fantastico/scripts/post_scripts_upgrade.php' ;
        if ( is_file ( $Post_Scripts_Upgrade ) )
        {
            include $Post_Scripts_Upgrade ;
        }
//------------------------------------------------------------------------------//
        $Temporary = Set_Fantastico_De_Luxe_Status ( 'On' ) ;
//------------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
?>
