<?php
//----------------------------------------------------------------------------//
    if ( $Secondary_Action == 'Edit' )
    {
//----------------------------------------------------------------------------//
        $Fantastico_De_Luxe_cPanel_Languages = Get_Files ( $Public_Settings['Paths']['cPanel']['Fantastico_De_Luxe'] . 'languages/' ) ;
        natcasesort ( $Fantastico_De_Luxe_cPanel_Languages ) ;
//----------------------------------------------------------------------------//
        $Fantastico_De_Luxe_WHM_Languages = Get_Files ( $Constants['Paths']['WHM']['Fantastico_De_Luxe'] . 'languages/' ) ;
        natcasesort ( $Fantastico_De_Luxe_WHM_Languages ) ;
//----------------------------------------------------------------------------//
?>

    <form action="<?php echo $Constants['URLs']['WHM']['Fantastico_De_Luxe'] ; ?>fantastico.php">

    <div class="Block">

        <h1><?php echo Get_Message ( 'Settings' ) ; ?></h1>

        <h1><?php echo Get_Message ( 'Fantastico De Luxe' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Fantastico De Luxe is ' ) ; ?>
            <select name="Fantastico">
                <option value="On" <?php if ( 'On' == $Public_Settings['Fantastico_De_Luxe']['Status'] ) echo 'selected="selected"' ; ?>><?php echo Get_Message ( 'enabled' ) ; ?></option>
                <option value="Off" <?php if ( 'Off' == $Public_Settings['Fantastico_De_Luxe']['Status'] ) echo 'selected="selected"' ; ?>><?php echo Get_Message ( 'disabled' ) ; ?></option>
            </select>
	    </p>

        <h1><?php echo Get_Message ( 'Language (in cPanel)' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Select the default language for the users' ) ; ?>
            <br/>
            <select name="cPanel_Language">
<?php
        foreach ( $Fantastico_De_Luxe_cPanel_Languages as $Language )
        {
            $Language = str_replace ( '.php' , '' , $Language ) ;
            if ( '.' != $Language AND '..' != $Language )
            {
                if ( $Language == $Public_Settings['Language'] )
                {
                    echo '<option value="' . $Language . '" selected="selected">' . $Language . '</option>' . "\n" ;
                }
                else if ( empty ( $Public_Settings['Language'] ) && $Language == 'English' )
                {
                    echo '<option value="' . $Language . '" selected="selected">' . $Language . '</option>' . "\n" ;
                }
                else
                {
                    echo '<option value="' . $Language . '">' . $Language . '</option>' . "\n" ;
                }
            }
        }
?>
            </select>
	    </p>
	    <p>
	        <?php echo Get_Message ( 'Note: Your users will still be able to select another language.' ) ; ?>
	    </p>

	    <h1><?php echo Get_Message ( 'Language (in WHM)' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Select the default language for Fantastico De Luxe WHM Admin' ) ; ?>
            <br/>
            <select name="WHM_Language">
<?php
        foreach ( $Fantastico_De_Luxe_WHM_Languages as $Language )
        {
            $Language = str_replace ( '.php' , '' , $Language ) ;
            if ( '.' != $Language AND '..' != $Language )
            {
                if ( $Language == $Private_Settings['Language'] )
                {
                    echo '<option value="' . $Language . '" selected="selected">' . $Language . '</option>' . "\n" ;
                }
                else if ( empty ( $Private_Settings['Language'] ) && $Language == 'English' )
                {
                    echo '<option value="' . $Language . '" selected="selected">' . $Language . '</option>' . "\n" ;
                }
                else
                {
                    echo '<option value="' . $Language . '">' . $Language . '</option>' . "\n" ;
                }
            }
        }
?>
            </select>
	    </p>

        <h1><?php echo Get_Message ( 'PHPsuexec' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'PHPsuexec is ' ) ; ?>
            <select name="phpsuexec">
                <option value="Off" <?php if ( 'Off' == $Public_Settings['phpsuexec']['Status'] ) echo 'selected="selected"' ; ?>><?php echo Get_Message ( 'not installed' ) ; ?></option>
                <option value="On" <?php if ( 'On' == $Public_Settings['phpsuexec']['Status'] ) echo 'selected="selected"' ; ?>><?php echo Get_Message ( 'installed' ) ; ?></option>
            </select>
        </p>
        <p>
            <?php echo Get_Message ( 'Note: this will not enable or disable PHPsuexec on your server. It will only configure Fantastico to work with it, if your server has PHPsuexec enabled.' ) ; ?>
        </p>

        <h1><?php echo Get_Message ( 'Path to netPBM' ) ; ?></h1>
        <p>
            <input type="text" name="NetPBM" value="<?php echo $Public_Settings['Binaries']['NetPBM'] ; ?>"/>
        </p>
        <p>
            <?php echo Get_Message ( 'Enter the path to %snetPBM%s in order to enable Gallery installations. If you installed netPBM using CPanel, then the path is probably %s/usr/bin/%s' , Array ( '<strong>' , '</strong>' , '<strong>' , '</strong>' ) ) ; ?>
        </p>

        <h1><?php echo Get_Message ( 'Path and filename to the "wget" binaries' ) ; ?></h1>
        <p>
            <input type="text" name="wget" value="<?php echo $Private_Settings['Binaries']['wget'] ; ?>"/>
        </p>
        <p>
            <?php echo Get_Message ( 'Fantastico needs fully working "wget" binaries with permissions set to at least 700 in order to work. For security reasons, you may have renamed the "wget" binaries. If so, enter here the full path and filename to the renamed "wget" binaries. Example: /usr/bin/mywget' ) ; ?>
        </p>

        <h1><?php echo Get_Message ( 'Select Fantastico licensing and files server' ) ; ?></h1>
        <p>
            <select name="Licensing_Server">
<?php
    foreach ( $Constants['Licensing_Servers'] as $Key => $Value )
    {
?>
                <option value="<?php echo $Key ; ?>"<?php if ( $Public_Settings['Licensing_Server'] == $Key ) { echo ' selected="selected"' ; } ?>><?php echo $Value ; ?></option>
<?php
    }
?>
            </select>
        </p>
        <p>
            <?php echo Get_Message ( 'Select the server that works best for you.%sNote: Fantastico will reset this value if the selected server does not respond.' , Array ( '<br/>' ) ) ; ?>
        </p>

        <h1><?php echo Get_Message ( 'Update Preference' ) ; ?></h1>
<?php
    $Stable_Selected = '' ;
    $Latest_Selected = '' ;
    if ( 'Stable' == $Public_Settings['Fantastico_De_Luxe']['Update_To'] )
    {
        $Stable_Selected = 'selected="selected"' ;
        $Latest_Selected = '' ;
    }
    if ( 'Latest' == $Public_Settings['Fantastico_De_Luxe']['Update_To'] )
    {
        $Stable_Selected = '' ;
        $Latest_Selected = 'selected="selected"' ;
    }
?>
        <p>
            <select name="Update_To">
                <option value="Latest" <?php echo $Latest_Selected ; ?>><?php echo Get_Message ( 'Get latest version' ) ; ?></option>
                <option value="Stable" <?php echo $Stable_Selected ; ?>><?php echo Get_Message ( 'Get stable version' ) ; ?></option>
            </select>
        </p>

        <h1><?php echo Get_Message ( 'Location of the netenberg data directory (approx 550 MB needed)' ) ; ?></h1>
        <p>
            <select name="Netenberg">
<?php
    $Directories = Get_Partitions_List ( ) ;
    foreach ( $Directories As $Key => $Value )
    {
        $Selected = '' ;
        if ( $Value['Value'] == str_replace ( '/' , '' , $Public_Settings['Paths']['Netenberg'] ) )
        {
            $Selected = ' selected="selected"' ;
        }
?>
                <option value="/<?php echo $Value['Value'] ; ?>/"<?php echo $Selected ; ?>><?php echo $Value['Caption'] ; ?></option>
<?php
    }
?>
            </select>
        </p>

        <h1><?php echo Get_Message ( 'Debug Mode' ) ; ?></h1>
<?php
    $On_Selected  = '' ;
    $Off_Selected = ' selected="selected"' ;
    if ( 'On' == $Private_Settings['Debug']['Status'] )
    {
        $On_Selected  = ' selected="selected"' ;
        $Off_Selected = '' ;
    }
    if ( 'Off' == $Private_Settings['Debug']['Status'] )
    {
        $On_Selected  = '' ;
        $Off_Selected = ' selected="selected"' ;
    }
?>
        <p>
            <select name="Debug">
                <option value="On"<?php echo $On_Selected ; ?>><?php echo Get_Message ( 'On' ) ; ?></option>
                <option value="Off"<?php echo $Off_Selected ; ?>><?php echo Get_Message ( 'Off' ) ; ?></option>
            </select>
        </p>

        <h1><?php echo Get_Message ( 'VPS' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Is this server a VPS server?' ) ; ?>
<?php
    $Yes_Selected  = '' ;
    $No_Selected = ' selected="selected"' ;
    if ( 'On' == $Private_Settings['VPS']['Status'] )
    {
        $Yes_Selected  = ' selected="selected"' ;
        $No_Selected = '' ;
    }
    if ( 'Off' == $Private_Settings['VPS']['Status'] )
    {
        $Yes_Selected  = '' ;
        $No_Selected = ' selected="selected"' ;
    }
?>
            <select name="VPS_Status">
                <option value="On"<?php echo $Yes_Selected ; ?>><?php echo Get_Message ( 'yes' ) ; ?></option>
                <option value="Off"<?php echo $No_Selected ; ?>><?php echo Get_Message ( 'no' ) ; ?></option>
            </select>
        </p>

        <h1><?php echo Get_Message ( 'wget time-out (in seconds)' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'If you are having problems connecting to our servers, set it to a value above 30.' ) ; ?>
        </p>
        <p>
            <input type="text" name="wget_Time_Out" value="<?php echo $Private_Settings['wget']['Time_Out'] ; ?>"/>
        </p>

        <p class="Center">
            <input type="submit" name="Submit" value="<?php echo Get_Message ( 'Save' ) ; ?>"/>
        </p>
    </div>

    <input type="hidden" name="Primary_Action"   value="Settings"/>
    <input type="hidden" name="Secondary_Action" value="Update"/>

    </form>

<?php
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
    if ( $Secondary_Action == 'Update' )
    {
//----------------------------------------------------------------------------//
        $Previous_Update_To = $Public_Settings['Fantastico_De_Luxe']['Update_To'] ;
        $Next_Update_To     = $_GET['Update_To'] ;
//----------------------------------------------------------------------------//
        if ( $Public_Settings['Paths']['Netenberg'] != $_GET['Netenberg'] )
        {
//----------------------------------------------------------------------------//
            $Command = 'mv -f ' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/ ' . $_GET['Netenberg'] ;
            $Output  = Get_Output ( $Command , 'Off' ) ;
            $Command = 'chmod 755 ' . $_GET['Netenberg'] . 'netenberg/' ;
            $Output  = Get_Output ( $Command , 'Off' ) ;
//----------------------------------------------------------------------------//
        }
//----------------------------------------------------------------------------//
        $Private_Settings['Binaries' ]['wget'          ] = Get_Sanitized_String ( $_GET['wget'         ] ) ;
        $Private_Settings['Debug'    ]['Status'        ] = Get_Sanitized_String ( $_GET['Debug'        ] ) ;
        $Private_Settings['Language' ]                   = Get_Sanitized_String ( $_GET['WHM_Language' ] ) ;
        $Private_Settings['wget'     ]['Time_Out'      ] = Get_Sanitized_String ( $_GET['wget_Time_Out'] ) ;
        $Private_Settings['VPS'      ]['Status'        ] = Get_Sanitized_String ( $_GET['VPS_Status'   ] ) ;
//----------------------------------------------------------------------------//
        $Public_Settings['Binaries'          ]['NetPBM'           ] = Get_Sanitized_String ( $_GET['NetPBM'           ] ) ;
        $Public_Settings['Language'          ]                      = Get_Sanitized_String ( $_GET['cPanel_Language'  ] ) ;
        $Public_Settings['Licensing_Server'  ]                      = Get_Sanitized_String ( $_GET['Licensing_Server' ] ) ;
        $Public_Settings['phpsuexec'         ]['Status'           ] = Get_Sanitized_String ( $_GET['phpsuexec'        ] ) ;
        $Public_Settings['Fantastico_De_Luxe']['Status'           ] = Get_Sanitized_String ( $_GET['Fantastico'       ] ) ;
        $Public_Settings['Fantastico_De_Luxe']['Update_To'        ] = Get_Sanitized_String ( $_GET['Update_To'        ] ) ;
//----------------------------------------------------------------------------//
        $Public_Settings['Paths']['Netenberg'] = Get_Sanitized_String ( $_GET['Netenberg'] ) ;
//----------------------------------------------------------------------------//
        $Temporary = Set_Private_Settings ( $Private_Settings ) ;
//----------------------------------------------------------------------------//
        $Temporary = Set_Public_Settings ( $Public_Settings ) ;
//----------------------------------------------------------------------------//
        $Temporary = Set_Fantastico_De_Luxe_WHM_Admin_Public_Settings ( $Public_Settings ) ;
//----------------------------------------------------------------------------//
?>
    <div class="Block">
        <h1><?php echo Get_Message ( 'Settings' ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Your changes were saved.' ) ; ?>
        </p>
    </div>
<?php
//----------------------------------------------------------------------------//
        if ( $Previous_Update_To != $Next_Update_To )
        {
//----------------------------------------------------------------------------//
            $Primary_Action   = 'Scripts'     ;
            $Secondary_Action = 'Update'      ;
            $Tertiary_Action  = 'All'         ;
            include $Constants['Paths']['WHM']['Fantastico_De_Luxe'] . 'actions/' . strtolower ( $Primary_Action ) . '.php' ;
//----------------------------------------------------------------------------//
        }
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
?>
