<?php
//------------------------------------------------------------------------------//
    include $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/public_settings.php' ;
//------------------------------------------------------------------------------//
    switch ( $Public_Settings['Usage_Rules'][$Secondary_Action]['Mode'] )
    {
        case 'White_List' :
            $Mode = 'enabled' ;
            $Caption = 'allowed' ;
            break ;
        case 'Black_List' :
        default           :
            $Mode = 'disabled' ;
            $Caption = 'restricted' ;
            break ;
    }
//------------------------------------------------------------------------------//
    if ( 'Manage' == $Tertiary_Action )
    {
//------------------------------------------------------------------------------//
        $Items = Array ( ) ;
//------------------------------------------------------------------------------//
        $Items = Get_Files ( $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/' . $Mode . '/' . strtolower ( $Secondary_Action ) . '/' ) ;
        foreach ( $Items As $Key => $Value )
        {
            if ( '.' == $Value OR '..' == $Value )
            {
                unset ( $Items[$Key] ) ;
            }
            else
            {
                $Items[$Key] = trim ( $Value ) ;
            }
        }
//------------------------------------------------------------------------------//
        natcasesort ( $Items ) ;
//------------------------------------------------------------------------------//
?>
    <div class="Block">
        <h1><?php echo Get_Message ( 'Restrict access using Usage Rules' ) ; ?></h1>
<?php
//------------------------------------------------------------------------------//

//------------------------------------------------------------------------------//
        if ( 'Hosting_Plans' == $Secondary_Action )
        {
//------------------------------------------------------------------------------//
?>
        <p>
            <?php echo Get_Message ( 'Use Usage Rules to restrict access to certain Hosting Plans. Users with a Hosting Plan with restricted status will still enter the Fantastico main screen but will get following message: %sThis hosting plan has no access to Fantastico. Upgrade your hosting plan to be able to use Fantastico.%s' , Array ( '<span class="Success">' , '</span>' ) ) ; ?>
        </p>
        <p>
            <span class="Success">
                <strong>
<?php
            if ( 'Black_List' == $Public_Settings['Usage_Rules']['Hosting_Plans']['Mode'] )
            {
                echo Get_Message ( 'All hosting plans are allowed to use Fantastico (unless a user or reseller limitation apply) except for the following:' ) ;
            }
            if ( 'White_List' == $Public_Settings['Usage_Rules']['Hosting_Plans']['Mode'] )
            {
                echo Get_Message ( 'Only hosting plans displayed here are allowed to use Fantastico (unless a user or reseller limitation apply):' ) ;
            }
?>
                </strong>
            </span>
        </p>
<?php
//------------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
        if ( 'Resellers' == $Secondary_Action )
        {
//------------------------------------------------------------------------------//
?>
        <p>
            <?php echo Get_Message ( 'Use Usage Rules to restrict access to certain Resellers. Users of Resellers with restricted status will still enter the Fantastico main screen but will get following message: %sYou are not allowed to use Fantastico. Please contact us to gain access to Fantastico.%s' , Array ( '<span class="Success">' , '</span>' ) ) ; ?>
        </p>
        <p>
            <span class="Success">
                <strong>
<?php
            if ( 'Black_List' == $Public_Settings['Usage_Rules']['Resellers']['Mode'] )
            {
                echo Get_Message ( 'All resellers&#39; clients are allowed to use Fantastico (unless a user or hosting plan limitation apply) except for the following:' ) ;
            }
            if ( 'White_List' == $Public_Settings['Usage_Rules']['Resellers']['Mode'] )
            {
                echo Get_Message ( 'Only clients of resellers displayed here are allowed to use Fantastico (unless a user or hosting plan limitation apply). Add reseller <b>&#39;root&#39;</b> to enable non resold accounts to use Fantastico:' ) ;
            }
?>
                </strong>
            </span>
        </p>
<?php
//------------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
        if ( 'Users' == $Secondary_Action )
        {
//------------------------------------------------------------------------------//
?>
        <p>
            <?php echo Get_Message ( 'Use Usage Rules to restrict access to certain Users. Users with restricted status will still enter the Fantastico main screen but will get following message: %sThis username is not allowed to use Fantastico. Please contact us to gain access to Fantastico.%s' , Array ( '<span class="Success">' , '</span>' ) ) ; ?>
        </p>
        <p>
            <span class="Success">
                <strong>
<?php
            if ( 'Black_List' == $Public_Settings['Usage_Rules']['Users']['Mode'] )
            {
                echo Get_Message ( 'All users are allowed to use Fantastico (unless a reseller or hosting plan limitation apply) except for the following:' ) ;
            }
            if ( 'White_List' == $Public_Settings['Usage_Rules']['Users']['Mode'] )
            {
                echo Get_Message ( 'Only users displayed here are allowed to use Fantastico no matter what reseller or hosting plan limitations might apply:' ) ;
            }
?>
                </strong>
            </span>
        </p>
<?php
//------------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
        if ( !empty ( $Items ) )
        {
//------------------------------------------------------------------------------//
?>
        <table>
<?php
//------------------------------------------------------------------------------//
            foreach ( $Items As $Item )
            {
//------------------------------------------------------------------------------//
?>
            <tr>
                <td class="Narrow"><?php echo $Item ; ?></td>
                <td class="Broad Right"><a href="<?php echo $Constants['URLs']['WHM']['Fantastico_De_Luxe'] ; ?>fantastico.php?Primary_Action=Usage_Rules&Secondary_Action=<?php echo $Secondary_Action ; ?>&Tertiary_Action=Remove&Item=<?php echo str_replace ( ' ' , '%20' , $Item ) ; ?>" title="<?php echo Get_Message ( 'Remove from list' ) ; ?>"><?php echo Get_Message ( 'Remove from list' ) ; ?></a></td>
            </tr>
<?php
//------------------------------------------------------------------------------//
            }
//------------------------------------------------------------------------------//
?>
        </table>
<?php
//------------------------------------------------------------------------------//
        }
        else
        {
//------------------------------------------------------------------------------//
?>
        <p>None</p>
<?php
//------------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
?>
    </div>

<form action="<?php echo $Constants['URLs']['WHM']['Fantastico_De_Luxe'] ; ?>fantastico.php" method="get">

<div class="Block">
<?php
//------------------------------------------------------------------------------//
    if ( 'Hosting_Plans' == $Secondary_Action )
    {
        if ( 'Black_List' == $Public_Settings['Usage_Rules']['Hosting_Plans']['Mode'] )
        {
?>
    <h1><?php echo Get_Message ( 'Add a hosting plan to the restricted list:' ) ; ?></h1>
<?php
        }
        if ( 'White_List' == $Public_Settings['Usage_Rules']['Hosting_Plans']['Mode'] )
        {
?>
    <h1><?php echo Get_Message ( 'Add a hosting plan to the allowed list:' ) ; ?></h1>
<?php
        }
//------------------------------------------------------------------------------//
        $Packages = Array ( ) ;
        $Packages = Get_Files ( $Constants['Paths']['cPanel']['Packages'] ) ;
        natcasesort ( $Packages ) ;
//------------------------------------------------------------------------------//
?>
    <p>
<?php
        if ( !empty ( $Packages ) )
        {
?>
        <select name="Item">
<?php
            foreach ( $Packages As $Package )
            {
?>
            <option value="<?php echo $Package ; ?>"><?php echo $Package ; ?></option>
<?php
            }
?>
        </select>
        <input type="submit" name="Submit" value="Add"/>
<?php
        }
        else
        {
            echo Get_Message ( 'There are no hosting plans configured on this server.' ) ;
        }
?>
    </p>
<?php
//------------------------------------------------------------------------------//
    }
//------------------------------------------------------------------------------//
    if ( 'Resellers' == $Secondary_Action )
    {
        if ( 'Black_List' == $Public_Settings['Usage_Rules']['Resellers']['Mode'] )
        {
?>
    <h1><?php echo Get_Message ( 'Add a reseller to the restricted list:' ) ; ?></h1>
<?php
        }
        if ( 'White_List' == $Public_Settings['Usage_Rules']['Resellers']['Mode'] )
        {
?>
    <h1><?php echo Get_Message ( 'Add a reseller to the allowed list:' ) ; ?></h1>
<?php
        }
        $Resellers = Get_Resellers ( ) ;
//------------------------------------------------------------------------------//
?>
    <p>
<?php
        if ( !empty ( $Resellers ) )
        {
?>
        <select name="Item">
<?php
            foreach ( $Resellers As $Reseller )
            {
?>
            <option value="<?php echo $Reseller ; ?>"><?php echo $Reseller ; ?></option>
<?php
            }
?>
        </select>
        <input type="submit" name="Submit" value="Add"/>
<?php
        }
        else
        {
            echo Get_Message ( 'There are no reseller accounts configured on this server.' ) ;
        }
?>
    </p>
<?php
//------------------------------------------------------------------------------//
    }
//------------------------------------------------------------------------------//
    if ( 'Users' == $Secondary_Action )
    {
        if ( 'Black_List' == $Public_Settings['Usage_Rules']['Users']['Mode'] )
        {
?>
    <h1><?php echo Get_Message ( 'Add a user to the restricted list:' ) ; ?></h1>
<?php
        }
        if ( 'White_List' == $Public_Settings['Usage_Rules']['Users']['Mode'] )
        {
?>
    <h1><?php echo Get_Message ( 'Add a user to the allowed list:' ) ; ?></h1>
<?php
        }
//------------------------------------------------------------------------------//
        $Users = Array ( ) ;
        $Users = Get_Files ( $Constants['Paths']['cPanel']['Users'] ) ;
        natcasesort ( $Users ) ;
//------------------------------------------------------------------------------//
?>
        <p>
<?php
            if ( !empty ( $Users ) )
            {
?>
            <select name="Item">
<?php
                foreach ( $Users As $User )
                {
                    if ( '.' != $User And '..' != $User )
                    {
?>
                <option value="<?php echo $User ; ?>"><?php echo $User ; ?></option>
<?php
                    }
                }
?>
            </select>
            <input type="submit" name="Submit" value="Add"/>
<?php
            }
            else
            {
                echo Get_Message ( 'There are no user accounts configured on this server.' ) ;
            }
?>
        </p>
<?php
//------------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
?>
    </div>

    <input type="hidden" name="Primary_Action"   value="Usage_Rules"/>
    <input type="hidden" name="Secondary_Action" value="<?php echo $Secondary_Action ; ?>"/>
    <input type="hidden" name="Tertiary_Action"  value="Add"/>

    </form>
<?php
//------------------------------------------------------------------------------//
        if ( 'Black_List' == $Public_Settings['Usage_Rules'][$Secondary_Action]['Mode'] )
        {
//------------------------------------------------------------------------------//
?>
    <div class="Block">
        <p>
            <a href="<?php echo $Constants['URLs']['WHM']['Fantastico_De_Luxe'] ; ?>fantastico.php?Primary_Action=Usage_Rules&Tertiary_Action=Change_Mode&Quaternary_Action=White_List&Secondary_Action=<?php echo $Secondary_Action ; ?>" title=""><strong><?php echo Get_Message ( 'Change mode to &#39;Allow specific&#39;') ; ?></strong></a>
        </p>
    </div>
<?php
//------------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
        if ( 'White_List' == $Public_Settings['Usage_Rules'][$Secondary_Action]['Mode'] )
        {
//------------------------------------------------------------------------------//
?>
    <div class="Block">
        <p>
            <a href="<?php echo $Constants['URLs']['WHM']['Fantastico_De_Luxe'] ; ?>fantastico.php?Primary_Action=Usage_Rules&Tertiary_Action=Change_Mode&Quaternary_Action=Black_List&Secondary_Action=<?php echo $Secondary_Action ; ?>" title=""><strong><?php echo Get_Message ( 'Change mode to &#39;Enable all&#39;' ) ; ?></strong></a>
        </p>
    </div>
<?php
//------------------------------------------------------------------------------//
        }
//------------------------------------------------------------------------------//
    }
//------------------------------------------------------------------------------//
    if ( 'Add' == $Tertiary_Action )
    {
//------------------------------------------------------------------------------//
?>
    <div class="Block">
<?php
//------------------------------------------------------------------------------//
        $Items = explode ( ',' , $_GET['Item'] ) ;
        if ( !empty ( $Items ) )
        {
	        foreach ( $Items As $Key => $Value )
	        {
	            $Value = trim ( $Value ) ;
	            if ( !empty ( $Value ) )
	            {
	                $Temporary = $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/' . $Mode . '/' . strtolower ( $Secondary_Action ) . '/' . $Value ;
	                if ( is_dir ( $Temporary ) )
	                {
	                    if ( 'Hosting_Plans' == $Secondary_Action )
	                    {
?>
        <p>
            <?php echo Get_Message ( '%sThis package (%s) is already listed!%s' , Array ( '<span class="Success"><strong>' , $Value , '</strong></span>' ) ) ; ?>
        </p>
<?php
                	     }
	                    if ( 'Resellers' == $Secondary_Action )
	                    {
?>
        <p>
            <?php echo Get_Message ( '%sThis reseller (%s) is already listed!%s' , Array ( '<span class="Success"><strong>' , $Value , '</strong></span>' ) ) ; ?>
        </p>
<?php
                	    }
	                    if ( 'Users' == $Secondary_Action )
	                    {
?>
        <p>
            <?php echo Get_Message ( '%sThis user (%s) is already listed!%s' , Array ( '<span class="Success"><strong>' , $Value , '</strong></span>' ) ) ; ?>
        </p>
<?php
 	                   }
	                }
	                else
	                {
	                    $Temporary = mkdir ( $Temporary , 0755 ) ;
	                    if ( 'Hosting_Plans' == $Secondary_Action )
	                    {
?>
        <p>
            <?php echo Get_Message ( 'Hosting plan %s was added to the list.' , Array ( '<span class="Success"><strong>' . $Value . '</strong></span>' ) ) ; ?>
        </p>
<?php
                  	  }
	                    if ( 'Resellers' == $Secondary_Action )
	                    {
?>
        <p>
            <?php echo Get_Message ( 'Reseller %s was added to the list.' , Array ( '<span class="Success"><strong>' . $Value . '</strong></span>' ) ) ; ?>
        </p>
<?php
                        }
                        if ( 'Users' == $Secondary_Action )
                        {
?>
        <p>
            <?php echo Get_Message ( 'User %s was added to the list.' , Array ( '<span class="Success"><strong>' . $Value . '</strong></span>' ) ) ; ?>
        </p>
<?php
                        }
                    }
                }
            }
        }
        else
        {
?>
        <p class="Failure">
            <?php echo Get_Message ( 'You have not specified a valid Hosting Plan.' ) ; ?>
        </p>
<?php
        }
//------------------------------------------------------------------------------//
?>
    </div>
<?php
//------------------------------------------------------------------------------//
        $Tertiary_Action = 'Manage' ;
        include $Constants['Paths']['WHM']['Fantastico_De_Luxe'] . 'actions/' . strtolower ( $Primary_Action ) . '.php' ;
//------------------------------------------------------------------------------//
    }
//------------------------------------------------------------------------------//
    if ( 'Remove' == $Tertiary_Action )
    {
//------------------------------------------------------------------------------//
?>
    <div class="Block">
<?php
//------------------------------------------------------------------------------//
        if ( !empty ( $_GET['Submit'] ) )
        {
//------------------------------------------------------------------------------//
            $Item = trim ( $Item ) ;
	        $Command = 'rm -rf "' . $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/' . $Mode . '/' . strtolower ( $Secondary_Action ) . '/' . $Item . '"' ;
            $Output = Get_Output ( $Command , 'Off' ) ;
//------------------------------------------------------------------------------//
	        if ( 'Hosting_Plans' == $Secondary_Action )
	        {
?>
        <p>
            <?php echo Get_Message ( '%s was removed from the list of %s %s.' , Array ( '<span class="Success"><strong>' . $Item . '</strong></span>' , $Caption , 'packages' ) ) ; ?>
        </p>
<?php
     	    }
	        if ( 'Resellers' == $Secondary_Action )
	        {
?>
        <p>
            <?php echo Get_Message ( '%s was removed from the list of %s %s.' , Array ( '<span class="Success"><strong>' . $Item . '</strong></span>' , $Caption , 'resellers' ) ) ; ?>
        </p>
<?php
     	    }
	        if ( 'Users' == $Secondary_Action )
	        {
?>
        <p>
            <?php echo Get_Message ( '%s was removed from the list of %s %s.' , Array ( '<span class="Success"><strong>' . $Item . '</strong></span>' , $Caption , 'users' ) ) ; ?>
        </p>
<?php
            }
//------------------------------------------------------------------------------//
            $Tertiary_Action = 'Manage' ;
            include $Constants['Paths']['WHM']['Fantastico_De_Luxe'] . 'actions/' . strtolower ( $Primary_Action ) . '.php' ;
//------------------------------------------------------------------------------//
        }
        else
        {
?>
<form action="<?php echo $Constants['URLs']['WHM']['Fantastico_De_Luxe'] ; ?>fantastico.php" method="get">
<?php
//------------------------------------------------------------------------------//
	        if ( 'Hosting_Plans' == $Secondary_Action )
	        {
?>
        <h1><?php echo Get_Message ( 'Remove from the list of %s %s' , Array ( $Caption , 'package' ) ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Are you sure you want to remove %s from the list of %s %s?' , Array ( '<span class="Success"><strong>' . $Item . '</strong></span>' , $Caption , 'package' ) ) ; ?>
        </p>
<?php
     	    }
	        if ( 'Resellers' == $Secondary_Action )
	        {
?>
        <h1><?php echo Get_Message ( 'Remove from the list of %s %s' , Array ( $Caption , 'reseller' ) ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Are you sure you want to remove %s from the list of %s %s?' , Array ( '<span class="Success"><strong>' . $Item . '</strong></span>' , $Caption , 'reseller' ) ) ; ?>
        </p>
<?php
     	    }
	        if ( 'Users' == $Secondary_Action )
	        {
?>
        <h1><?php echo Get_Message ( 'Remove from the list of %s %s' , Array ( $Caption , 'user' ) ) ; ?></h1>
        <p>
            <?php echo Get_Message ( 'Are you sure you want to remove %s from the list of %s %s?' , Array ( '<span class="Success"><strong>' . $Item . '</strong></span>' , $Caption , 'user' ) ) ; ?>
        </p>
<?php
            }
//------------------------------------------------------------------------------//
?>
    <p class="Center">
        <input type="submit" name="Submit" value="<?php echo Get_Message ( 'Yes' ) ; ?>"/>
    </p>

    <input type="hidden" name="Primary_Action"   value="Usage_Rules"/>
    <input type="hidden" name="Secondary_Action" value="<?php echo $Secondary_Action ; ?>"/>
    <input type="hidden" name="Tertiary_Action"  value="Remove"/>
    <input type="hidden" name="Item"             value="<?php echo $Item ; ?>"/>

</form>
<?php
        }
//------------------------------------------------------------------------------//
?>
    </div>
<?php
//------------------------------------------------------------------------------//
    }
//------------------------------------------------------------------------------//
    if ( 'Change_Mode' == $Tertiary_Action )
    {
//------------------------------------------------------------------------------//
        $Public_Settings['Usage_Rules'][$Secondary_Action]['Mode'] = $Quaternary_Action ;
        $Handle = fopen  ( $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/public_settings.php' , 'w' ) ;
        if ( TRUE == $Handle )
        {
            $Temporary = fwrite ( $Handle , '<?php' . "\n" ) ;
            $Temporary = fwrite ( $Handle , '//----------------------------------------------------------------------------//'                                                               . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Usage_Rules\'][\'Hosting_Plans\'][\'Mode\'] = \'' . $Public_Settings['Usage_Rules']['Hosting_Plans']['Mode'] . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Usage_Rules\'][\'Resellers\'    ][\'Mode\'] = \'' . $Public_Settings['Usage_Rules']['Resellers'    ]['Mode'] . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , "\t" . '$Public_Settings[\'Usage_Rules\'][\'Users\'        ][\'Mode\'] = \'' . $Public_Settings['Usage_Rules']['Users'        ]['Mode'] . '\' ;' . "\n" ) ;
            $Temporary = fwrite ( $Handle , '//----------------------------------------------------------------------------//'                                                               . "\n" ) ;
            $Temporary = fwrite ( $Handle , '?>' ) ;
            $Temporary = fclose ( $Handle        ) ;
            $Temporary = chmod ( $Public_Settings['Paths']['Netenberg'] . 'netenberg/fantastico_de_luxe/usage_rules/public_settings.php' , 0644 ) ;
        }
//------------------------------------------------------------------------------//
        $Tertiary_Action = 'Manage' ;
        include $Constants['Paths']['WHM']['Fantastico_De_Luxe'] . 'actions/' . strtolower ( $Primary_Action ) . '.php' ;
//------------------------------------------------------------------------------//
    }
//------------------------------------------------------------------------------//
?>